import { injectGlobal as Zt, css as yt } from "@emotion/css";
export * from "@emotion/css";
import { ref as Q, inject as Xt, defineComponent as Nt, computed as ct, createVNode as jt, mergeProps as Kt, provide as Qt, watch as te } from "vue";
import { toKebabCase as tt, toCapitalize as rt, isString as w } from "@interface-ui/utils";
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function H(t) {
  return t < 0 ? -1 : t === 0 ? 0 : 1;
}
function st(t, e, r) {
  return (1 - r) * t + r * e;
}
function ee(t, e, r) {
  return r < t ? t : r > e ? e : r;
}
function mt(t, e, r) {
  return r < t ? t : r > e ? e : r;
}
function Tt(t) {
  return t = t % 360, t < 0 && (t = t + 360), t;
}
function re(t, e) {
  return Tt(e - t) <= 180 ? 1 : -1;
}
function ne(t, e) {
  return 180 - Math.abs(Math.abs(t - e) - 180);
}
function Ct(t, e) {
  const r = t[0] * e[0][0] + t[1] * e[0][1] + t[2] * e[0][2], a = t[0] * e[1][0] + t[1] * e[1][1] + t[2] * e[1][2], n = t[0] * e[2][0] + t[1] * e[2][1] + t[2] * e[2][2];
  return [r, a, n];
}
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
const ae = [
  [0.41233895, 0.35762064, 0.18051042],
  [0.2126, 0.7152, 0.0722],
  [0.01932141, 0.11916382, 0.95034478]
], oe = [
  [
    3.2413774792388685,
    -1.5376652402851851,
    -0.49885366846268053
  ],
  [
    -0.9691452513005321,
    1.8758853451067872,
    0.04156585616912061
  ],
  [
    0.05562093689691305,
    -0.20395524564742123,
    1.0571799111220335
  ]
], se = [95.047, 100, 108.883];
function Mt(t, e, r) {
  return (255 << 24 | (t & 255) << 16 | (e & 255) << 8 | r & 255) >>> 0;
}
function Ot(t) {
  const e = et(t[0]), r = et(t[1]), a = et(t[2]);
  return Mt(e, r, a);
}
function ie(t) {
  return t >> 24 & 255;
}
function At(t) {
  return t >> 16 & 255;
}
function Dt(t) {
  return t >> 8 & 255;
}
function wt(t) {
  return t & 255;
}
function ce(t, e, r) {
  const a = oe, n = a[0][0] * t + a[0][1] * e + a[0][2] * r, o = a[1][0] * t + a[1][1] * e + a[1][2] * r, s = a[2][0] * t + a[2][1] * e + a[2][2] * r, c = et(n), u = et(o), f = et(s);
  return Mt(c, u, f);
}
function ue(t) {
  const e = nt(At(t)), r = nt(Dt(t)), a = nt(wt(t));
  return Ct([e, r, a], ae);
}
function fe(t) {
  const e = K(t), r = et(e);
  return Mt(r, r, r);
}
function Pt(t) {
  const e = ue(t)[1];
  return 116 * Wt(e / 100) - 16;
}
function K(t) {
  return 100 * pe((t + 16) / 116);
}
function kt(t) {
  return Wt(t / 100) * 116 - 16;
}
function nt(t) {
  const e = t / 255;
  return e <= 0.040449936 ? e / 12.92 * 100 : Math.pow((e + 0.055) / 1.055, 2.4) * 100;
}
function et(t) {
  const e = t / 100;
  let r = 0;
  return e <= 31308e-7 ? r = e * 12.92 : r = 1.055 * Math.pow(e, 1 / 2.4) - 0.055, ee(0, 255, Math.round(r * 255));
}
function le() {
  return se;
}
function at(t) {
  const e = At(t), r = Dt(t), a = wt(t), n = ie(t);
  return { r: e, g: r, b: a, a: n };
}
function Wt(t) {
  const e = 0.008856451679035631, r = 24389 / 27;
  return t > e ? Math.pow(t, 1 / 3) : (r * t + 16) / 116;
}
function pe(t) {
  const e = 0.008856451679035631, r = 24389 / 27, a = t * t * t;
  return a > e ? a : (116 * t - 16) / r;
}
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class U {
  /**
   * Create ViewingConditions from a simple, physically relevant, set of
   * parameters.
   *
   * @param whitePoint White point, measured in the XYZ color space.
   *     default = D65, or sunny day afternoon
   * @param adaptingLuminance The luminance of the adapting field. Informally,
   *     how bright it is in the room where the color is viewed. Can be
   *     calculated from lux by multiplying lux by 0.0586. default = 11.72,
   *     or 200 lux.
   * @param backgroundLstar The lightness of the area surrounding the color.
   *     measured by L* in L*a*b*. default = 50.0
   * @param surround A general description of the lighting surrounding the
   *     color. 0 is pitch dark, like watching a movie in a theater. 1.0 is a
   *     dimly light room, like watching TV at home at night. 2.0 means there
   *     is no difference between the lighting on the color and around it.
   *     default = 2.0
   * @param discountingIlluminant Whether the eye accounts for the tint of the
   *     ambient lighting, such as knowing an apple is still red in green light.
   *     default = false, the eye does not perform this process on
   *       self-luminous objects like displays.
   */
  static make(e = le(), r = 200 / Math.PI * K(50) / 100, a = 50, n = 2, o = !1) {
    const s = e, c = s[0] * 0.401288 + s[1] * 0.650173 + s[2] * -0.051461, u = s[0] * -0.250268 + s[1] * 1.204414 + s[2] * 0.045854, f = s[0] * -2079e-6 + s[1] * 0.048952 + s[2] * 0.953127, l = 0.8 + n / 10, m = l >= 0.9 ? st(0.59, 0.69, (l - 0.9) * 10) : st(0.525, 0.59, (l - 0.8) * 10);
    let g = o ? 1 : l * (1 - 1 / 3.6 * Math.exp((-r - 42) / 92));
    g = g > 1 ? 1 : g < 0 ? 0 : g;
    const b = l, x = [
      g * (100 / c) + 1 - g,
      g * (100 / u) + 1 - g,
      g * (100 / f) + 1 - g
    ], y = 1 / (5 * r + 1), M = y * y * y * y, F = 1 - M, D = M * r + 0.1 * F * F * Math.cbrt(5 * r), k = K(a) / e[1], V = 1.48 + Math.sqrt(k), P = 0.725 / Math.pow(k, 0.2), L = P, A = [
      Math.pow(D * x[0] * c / 100, 0.42),
      Math.pow(D * x[1] * u / 100, 0.42),
      Math.pow(D * x[2] * f / 100, 0.42)
    ], B = [
      400 * A[0] / (A[0] + 27.13),
      400 * A[1] / (A[1] + 27.13),
      400 * A[2] / (A[2] + 27.13)
    ], v = (2 * B[0] + B[1] + 0.05 * B[2]) * P;
    return new U(k, v, P, L, m, b, x, D, Math.pow(D, 0.25), V);
  }
  /**
   * Parameters are intermediate values of the CAM16 conversion process. Their
   * names are shorthand for technical color science terminology, this class
   * would not benefit from documenting them individually. A brief overview
   * is available in the CAM16 specification, and a complete overview requires
   * a color science textbook, such as Fairchild's Color Appearance Models.
   */
  constructor(e, r, a, n, o, s, c, u, f, l) {
    this.n = e, this.aw = r, this.nbb = a, this.ncb = n, this.c = o, this.nc = s, this.rgbD = c, this.fl = u, this.fLRoot = f, this.z = l;
  }
}
U.DEFAULT = U.make();
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class $ {
  /**
   * All of the CAM16 dimensions can be calculated from 3 of the dimensions, in
   * the following combinations:
   *      -  {j or q} and {c, m, or s} and hue
   *      - jstar, astar, bstar
   * Prefer using a static method that constructs from 3 of those dimensions.
   * This constructor is intended for those methods to use to return all
   * possible dimensions.
   *
   * @param hue
   * @param chroma informally, colorfulness / color intensity. like saturation
   *     in HSL, except perceptually accurate.
   * @param j lightness
   * @param q brightness; ratio of lightness to white point's lightness
   * @param m colorfulness
   * @param s saturation; ratio of chroma to white point's chroma
   * @param jstar CAM16-UCS J coordinate
   * @param astar CAM16-UCS a coordinate
   * @param bstar CAM16-UCS b coordinate
   */
  constructor(e, r, a, n, o, s, c, u, f) {
    this.hue = e, this.chroma = r, this.j = a, this.q = n, this.m = o, this.s = s, this.jstar = c, this.astar = u, this.bstar = f;
  }
  /**
   * CAM16 instances also have coordinates in the CAM16-UCS space, called J*,
   * a*, b*, or jstar, astar, bstar in code. CAM16-UCS is included in the CAM16
   * specification, and is used to measure distances between colors.
   */
  distance(e) {
    const r = this.jstar - e.jstar, a = this.astar - e.astar, n = this.bstar - e.bstar, o = Math.sqrt(r * r + a * a + n * n);
    return 1.41 * Math.pow(o, 0.63);
  }
  /**
   * @param argb ARGB representation of a color.
   * @return CAM16 color, assuming the color was viewed in default viewing
   *     conditions.
   */
  static fromInt(e) {
    return $.fromIntInViewingConditions(e, U.DEFAULT);
  }
  /**
   * @param argb ARGB representation of a color.
   * @param viewingConditions Information about the environment where the color
   *     was observed.
   * @return CAM16 color.
   */
  static fromIntInViewingConditions(e, r) {
    const a = (e & 16711680) >> 16, n = (e & 65280) >> 8, o = e & 255, s = nt(a), c = nt(n), u = nt(o), f = 0.41233895 * s + 0.35762064 * c + 0.18051042 * u, l = 0.2126 * s + 0.7152 * c + 0.0722 * u, m = 0.01932141 * s + 0.11916382 * c + 0.95034478 * u, g = 0.401288 * f + 0.650173 * l - 0.051461 * m, b = -0.250268 * f + 1.204414 * l + 0.045854 * m, x = -2079e-6 * f + 0.048952 * l + 0.953127 * m, y = r.rgbD[0] * g, M = r.rgbD[1] * b, F = r.rgbD[2] * x, D = Math.pow(r.fl * Math.abs(y) / 100, 0.42), k = Math.pow(r.fl * Math.abs(M) / 100, 0.42), V = Math.pow(r.fl * Math.abs(F) / 100, 0.42), P = H(y) * 400 * D / (D + 27.13), L = H(M) * 400 * k / (k + 27.13), A = H(F) * 400 * V / (V + 27.13), B = (11 * P + -12 * L + A) / 11, v = (P + L - 2 * A) / 9, S = (20 * P + 20 * L + 21 * A) / 20, Y = (40 * P + 20 * L + A) / 20, _ = Math.atan2(v, B) * 180 / Math.PI, j = _ < 0 ? _ + 360 : _ >= 360 ? _ - 360 : _, ft = j * Math.PI / 180, lt = Y * r.nbb, X = 100 * Math.pow(lt / r.aw, r.c * r.z), pt = 4 / r.c * Math.sqrt(X / 100) * (r.aw + 4) * r.fLRoot, dt = j < 20.14 ? j + 360 : j, gt = 0.25 * (Math.cos(dt * Math.PI / 180 + 2) + 3.8), xt = 5e4 / 13 * gt * r.nc * r.ncb * Math.sqrt(B * B + v * v) / (S + 0.305), ht = Math.pow(xt, 0.9) * Math.pow(1.64 - Math.pow(0.29, r.n), 0.73), It = ht * Math.sqrt(X / 100), Bt = It * r.fLRoot, qt = 50 * Math.sqrt(ht * r.c / (r.aw + 4)), Yt = (1 + 100 * 7e-3) * X / (1 + 7e-3 * X), Lt = 1 / 0.0228 * Math.log(1 + 0.0228 * Bt), Gt = Lt * Math.cos(ft), Jt = Lt * Math.sin(ft);
    return new $(j, It, X, pt, Bt, qt, Yt, Gt, Jt);
  }
  /**
   * @param j CAM16 lightness
   * @param c CAM16 chroma
   * @param h CAM16 hue
   */
  static fromJch(e, r, a) {
    return $.fromJchInViewingConditions(e, r, a, U.DEFAULT);
  }
  /**
   * @param j CAM16 lightness
   * @param c CAM16 chroma
   * @param h CAM16 hue
   * @param viewingConditions Information about the environment where the color
   *     was observed.
   */
  static fromJchInViewingConditions(e, r, a, n) {
    const o = 4 / n.c * Math.sqrt(e / 100) * (n.aw + 4) * n.fLRoot, s = r * n.fLRoot, c = r / Math.sqrt(e / 100), u = 50 * Math.sqrt(c * n.c / (n.aw + 4)), f = a * Math.PI / 180, l = (1 + 100 * 7e-3) * e / (1 + 7e-3 * e), m = 1 / 0.0228 * Math.log(1 + 0.0228 * s), g = m * Math.cos(f), b = m * Math.sin(f);
    return new $(a, r, e, o, s, u, l, g, b);
  }
  /**
   * @param jstar CAM16-UCS lightness.
   * @param astar CAM16-UCS a dimension. Like a* in L*a*b*, it is a Cartesian
   *     coordinate on the Y axis.
   * @param bstar CAM16-UCS b dimension. Like a* in L*a*b*, it is a Cartesian
   *     coordinate on the X axis.
   */
  static fromUcs(e, r, a) {
    return $.fromUcsInViewingConditions(e, r, a, U.DEFAULT);
  }
  /**
   * @param jstar CAM16-UCS lightness.
   * @param astar CAM16-UCS a dimension. Like a* in L*a*b*, it is a Cartesian
   *     coordinate on the Y axis.
   * @param bstar CAM16-UCS b dimension. Like a* in L*a*b*, it is a Cartesian
   *     coordinate on the X axis.
   * @param viewingConditions Information about the environment where the color
   *     was observed.
   */
  static fromUcsInViewingConditions(e, r, a, n) {
    const o = r, s = a, c = Math.sqrt(o * o + s * s), f = (Math.exp(c * 0.0228) - 1) / 0.0228 / n.fLRoot;
    let l = Math.atan2(s, o) * (180 / Math.PI);
    l < 0 && (l += 360);
    const m = e / (1 - (e - 100) * 7e-3);
    return $.fromJchInViewingConditions(m, f, l, n);
  }
  /**
   *  @return ARGB representation of color, assuming the color was viewed in
   *     default viewing conditions, which are near-identical to the default
   *     viewing conditions for sRGB.
   */
  toInt() {
    return this.viewed(U.DEFAULT);
  }
  /**
   * @param viewingConditions Information about the environment where the color
   *     will be viewed.
   * @return ARGB representation of color
   */
  viewed(e) {
    const r = this.chroma === 0 || this.j === 0 ? 0 : this.chroma / Math.sqrt(this.j / 100), a = Math.pow(r / Math.pow(1.64 - Math.pow(0.29, e.n), 0.73), 1 / 0.9), n = this.hue * Math.PI / 180, o = 0.25 * (Math.cos(n + 2) + 3.8), s = e.aw * Math.pow(this.j / 100, 1 / e.c / e.z), c = o * (5e4 / 13) * e.nc * e.ncb, u = s / e.nbb, f = Math.sin(n), l = Math.cos(n), m = 23 * (u + 0.305) * a / (23 * c + 11 * a * l + 108 * a * f), g = m * l, b = m * f, x = (460 * u + 451 * g + 288 * b) / 1403, y = (460 * u - 891 * g - 261 * b) / 1403, M = (460 * u - 220 * g - 6300 * b) / 1403, F = Math.max(0, 27.13 * Math.abs(x) / (400 - Math.abs(x))), D = H(x) * (100 / e.fl) * Math.pow(F, 1 / 0.42), k = Math.max(0, 27.13 * Math.abs(y) / (400 - Math.abs(y))), V = H(y) * (100 / e.fl) * Math.pow(k, 1 / 0.42), P = Math.max(0, 27.13 * Math.abs(M) / (400 - Math.abs(M))), L = H(M) * (100 / e.fl) * Math.pow(P, 1 / 0.42), A = D / e.rgbD[0], B = V / e.rgbD[1], v = L / e.rgbD[2], S = 1.86206786 * A - 1.01125463 * B + 0.14918677 * v, Y = 0.38752654 * A + 0.62144744 * B - 897398e-8 * v, Z = -0.0158415 * A - 0.03412294 * B + 1.04996444 * v;
    return ce(S, Y, Z);
  }
  /// Given color expressed in XYZ and viewed in [viewingConditions], convert to
  /// CAM16.
  static fromXyzInViewingConditions(e, r, a, n) {
    const o = 0.401288 * e + 0.650173 * r - 0.051461 * a, s = -0.250268 * e + 1.204414 * r + 0.045854 * a, c = -2079e-6 * e + 0.048952 * r + 0.953127 * a, u = n.rgbD[0] * o, f = n.rgbD[1] * s, l = n.rgbD[2] * c, m = Math.pow(n.fl * Math.abs(u) / 100, 0.42), g = Math.pow(n.fl * Math.abs(f) / 100, 0.42), b = Math.pow(n.fl * Math.abs(l) / 100, 0.42), x = H(u) * 400 * m / (m + 27.13), y = H(f) * 400 * g / (g + 27.13), M = H(l) * 400 * b / (b + 27.13), F = (11 * x + -12 * y + M) / 11, D = (x + y - 2 * M) / 9, k = (20 * x + 20 * y + 21 * M) / 20, V = (40 * x + 20 * y + M) / 20, L = Math.atan2(D, F) * 180 / Math.PI, A = L < 0 ? L + 360 : L >= 360 ? L - 360 : L, B = A * Math.PI / 180, v = V * n.nbb, S = 100 * Math.pow(v / n.aw, n.c * n.z), Y = 4 / n.c * Math.sqrt(S / 100) * (n.aw + 4) * n.fLRoot, Z = A < 20.14 ? A + 360 : A, _ = 1 / 4 * (Math.cos(Z * Math.PI / 180 + 2) + 3.8), ft = 5e4 / 13 * _ * n.nc * n.ncb * Math.sqrt(F * F + D * D) / (k + 0.305), lt = Math.pow(ft, 0.9) * Math.pow(1.64 - Math.pow(0.29, n.n), 0.73), X = lt * Math.sqrt(S / 100), pt = X * n.fLRoot, dt = 50 * Math.sqrt(lt * n.c / (n.aw + 4)), gt = (1 + 100 * 7e-3) * S / (1 + 7e-3 * S), bt = Math.log(1 + 0.0228 * pt) / 0.0228, xt = bt * Math.cos(B), ht = bt * Math.sin(B);
    return new $(A, X, S, Y, pt, dt, gt, xt, ht);
  }
  /// XYZ representation of CAM16 seen in [viewingConditions].
  xyzInViewingConditions(e) {
    const r = this.chroma === 0 || this.j === 0 ? 0 : this.chroma / Math.sqrt(this.j / 100), a = Math.pow(r / Math.pow(1.64 - Math.pow(0.29, e.n), 0.73), 1 / 0.9), n = this.hue * Math.PI / 180, o = 0.25 * (Math.cos(n + 2) + 3.8), s = e.aw * Math.pow(this.j / 100, 1 / e.c / e.z), c = o * (5e4 / 13) * e.nc * e.ncb, u = s / e.nbb, f = Math.sin(n), l = Math.cos(n), m = 23 * (u + 0.305) * a / (23 * c + 11 * a * l + 108 * a * f), g = m * l, b = m * f, x = (460 * u + 451 * g + 288 * b) / 1403, y = (460 * u - 891 * g - 261 * b) / 1403, M = (460 * u - 220 * g - 6300 * b) / 1403, F = Math.max(0, 27.13 * Math.abs(x) / (400 - Math.abs(x))), D = H(x) * (100 / e.fl) * Math.pow(F, 1 / 0.42), k = Math.max(0, 27.13 * Math.abs(y) / (400 - Math.abs(y))), V = H(y) * (100 / e.fl) * Math.pow(k, 1 / 0.42), P = Math.max(0, 27.13 * Math.abs(M) / (400 - Math.abs(M))), L = H(M) * (100 / e.fl) * Math.pow(P, 1 / 0.42), A = D / e.rgbD[0], B = V / e.rgbD[1], v = L / e.rgbD[2], S = 1.86206786 * A - 1.01125463 * B + 0.14918677 * v, Y = 0.38752654 * A + 0.62144744 * B - 897398e-8 * v, Z = -0.0158415 * A - 0.03412294 * B + 1.04996444 * v;
    return [S, Y, Z];
  }
}
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class h {
  /**
   * Sanitizes a small enough angle in radians.
   *
   * @param angle An angle in radians; must not deviate too much
   * from 0.
   * @return A coterminal angle between 0 and 2pi.
   */
  static sanitizeRadians(e) {
    return (e + Math.PI * 8) % (Math.PI * 2);
  }
  /**
   * Delinearizes an RGB component, returning a floating-point
   * number.
   *
   * @param rgbComponent 0.0 <= rgb_component <= 100.0, represents
   * linear R/G/B channel
   * @return 0.0 <= output <= 255.0, color channel converted to
   * regular RGB space
   */
  static trueDelinearized(e) {
    const r = e / 100;
    let a = 0;
    return r <= 31308e-7 ? a = r * 12.92 : a = 1.055 * Math.pow(r, 1 / 2.4) - 0.055, a * 255;
  }
  static chromaticAdaptation(e) {
    const r = Math.pow(Math.abs(e), 0.42);
    return H(e) * 400 * r / (r + 27.13);
  }
  /**
   * Returns the hue of a linear RGB color in CAM16.
   *
   * @param linrgb The linear RGB coordinates of a color.
   * @return The hue of the color in CAM16, in radians.
   */
  static hueOf(e) {
    const r = Ct(e, h.SCALED_DISCOUNT_FROM_LINRGB), a = h.chromaticAdaptation(r[0]), n = h.chromaticAdaptation(r[1]), o = h.chromaticAdaptation(r[2]), s = (11 * a + -12 * n + o) / 11, c = (a + n - 2 * o) / 9;
    return Math.atan2(c, s);
  }
  static areInCyclicOrder(e, r, a) {
    const n = h.sanitizeRadians(r - e), o = h.sanitizeRadians(a - e);
    return n < o;
  }
  /**
   * Solves the lerp equation.
   *
   * @param source The starting number.
   * @param mid The number in the middle.
   * @param target The ending number.
   * @return A number t such that lerp(source, target, t) = mid.
   */
  static intercept(e, r, a) {
    return (r - e) / (a - e);
  }
  static lerpPoint(e, r, a) {
    return [
      e[0] + (a[0] - e[0]) * r,
      e[1] + (a[1] - e[1]) * r,
      e[2] + (a[2] - e[2]) * r
    ];
  }
  /**
   * Intersects a segment with a plane.
   *
   * @param source The coordinates of point A.
   * @param coordinate The R-, G-, or B-coordinate of the plane.
   * @param target The coordinates of point B.
   * @param axis The axis the plane is perpendicular with. (0: R, 1:
   * G, 2: B)
   * @return The intersection point of the segment AB with the plane
   * R=coordinate, G=coordinate, or B=coordinate
   */
  static setCoordinate(e, r, a, n) {
    const o = h.intercept(e[n], r, a[n]);
    return h.lerpPoint(e, o, a);
  }
  static isBounded(e) {
    return 0 <= e && e <= 100;
  }
  /**
   * Returns the nth possible vertex of the polygonal intersection.
   *
   * @param y The Y value of the plane.
   * @param n The zero-based index of the point. 0 <= n <= 11.
   * @return The nth possible vertex of the polygonal intersection
   * of the y plane and the RGB cube, in linear RGB coordinates, if
   * it exists. If this possible vertex lies outside of the cube,
   * [-1.0, -1.0, -1.0] is returned.
   */
  static nthVertex(e, r) {
    const a = h.Y_FROM_LINRGB[0], n = h.Y_FROM_LINRGB[1], o = h.Y_FROM_LINRGB[2], s = r % 4 <= 1 ? 0 : 100, c = r % 2 === 0 ? 0 : 100;
    if (r < 4) {
      const u = s, f = c, l = (e - u * n - f * o) / a;
      return h.isBounded(l) ? [l, u, f] : [-1, -1, -1];
    } else if (r < 8) {
      const u = s, f = c, l = (e - f * a - u * o) / n;
      return h.isBounded(l) ? [f, l, u] : [-1, -1, -1];
    } else {
      const u = s, f = c, l = (e - u * a - f * n) / o;
      return h.isBounded(l) ? [u, f, l] : [-1, -1, -1];
    }
  }
  /**
   * Finds the segment containing the desired color.
   *
   * @param y The Y value of the color.
   * @param targetHue The hue of the color.
   * @return A list of two sets of linear RGB coordinates, each
   * corresponding to an endpoint of the segment containing the
   * desired color.
   */
  static bisectToSegment(e, r) {
    let a = [-1, -1, -1], n = a, o = 0, s = 0, c = !1, u = !0;
    for (let f = 0; f < 12; f++) {
      const l = h.nthVertex(e, f);
      if (l[0] < 0)
        continue;
      const m = h.hueOf(l);
      if (!c) {
        a = l, n = l, o = m, s = m, c = !0;
        continue;
      }
      (u || h.areInCyclicOrder(o, m, s)) && (u = !1, h.areInCyclicOrder(o, r, m) ? (n = l, s = m) : (a = l, o = m));
    }
    return [a, n];
  }
  static midpoint(e, r) {
    return [
      (e[0] + r[0]) / 2,
      (e[1] + r[1]) / 2,
      (e[2] + r[2]) / 2
    ];
  }
  static criticalPlaneBelow(e) {
    return Math.floor(e - 0.5);
  }
  static criticalPlaneAbove(e) {
    return Math.ceil(e - 0.5);
  }
  /**
   * Finds a color with the given Y and hue on the boundary of the
   * cube.
   *
   * @param y The Y value of the color.
   * @param targetHue The hue of the color.
   * @return The desired color, in linear RGB coordinates.
   */
  static bisectToLimit(e, r) {
    const a = h.bisectToSegment(e, r);
    let n = a[0], o = h.hueOf(n), s = a[1];
    for (let c = 0; c < 3; c++)
      if (n[c] !== s[c]) {
        let u = -1, f = 255;
        n[c] < s[c] ? (u = h.criticalPlaneBelow(h.trueDelinearized(n[c])), f = h.criticalPlaneAbove(h.trueDelinearized(s[c]))) : (u = h.criticalPlaneAbove(h.trueDelinearized(n[c])), f = h.criticalPlaneBelow(h.trueDelinearized(s[c])));
        for (let l = 0; l < 8 && !(Math.abs(f - u) <= 1); l++) {
          const m = Math.floor((u + f) / 2), g = h.CRITICAL_PLANES[m], b = h.setCoordinate(n, g, s, c), x = h.hueOf(b);
          h.areInCyclicOrder(o, r, x) ? (s = b, f = m) : (n = b, o = x, u = m);
        }
      }
    return h.midpoint(n, s);
  }
  static inverseChromaticAdaptation(e) {
    const r = Math.abs(e), a = Math.max(0, 27.13 * r / (400 - r));
    return H(e) * Math.pow(a, 1 / 0.42);
  }
  /**
   * Finds a color with the given hue, chroma, and Y.
   *
   * @param hueRadians The desired hue in radians.
   * @param chroma The desired chroma.
   * @param y The desired Y.
   * @return The desired color as a hexadecimal integer, if found; 0
   * otherwise.
   */
  static findResultByJ(e, r, a) {
    let n = Math.sqrt(a) * 11;
    const o = U.DEFAULT, s = 1 / Math.pow(1.64 - Math.pow(0.29, o.n), 0.73), u = 0.25 * (Math.cos(e + 2) + 3.8) * (5e4 / 13) * o.nc * o.ncb, f = Math.sin(e), l = Math.cos(e);
    for (let m = 0; m < 5; m++) {
      const g = n / 100, b = r === 0 || n === 0 ? 0 : r / Math.sqrt(g), x = Math.pow(b * s, 1 / 0.9), M = o.aw * Math.pow(g, 1 / o.c / o.z) / o.nbb, F = 23 * (M + 0.305) * x / (23 * u + 11 * x * l + 108 * x * f), D = F * l, k = F * f, V = (460 * M + 451 * D + 288 * k) / 1403, P = (460 * M - 891 * D - 261 * k) / 1403, L = (460 * M - 220 * D - 6300 * k) / 1403, A = h.inverseChromaticAdaptation(V), B = h.inverseChromaticAdaptation(P), v = h.inverseChromaticAdaptation(L), S = Ct([A, B, v], h.LINRGB_FROM_SCALED_DISCOUNT);
      if (S[0] < 0 || S[1] < 0 || S[2] < 0)
        return 0;
      const Y = h.Y_FROM_LINRGB[0], Z = h.Y_FROM_LINRGB[1], _ = h.Y_FROM_LINRGB[2], j = Y * S[0] + Z * S[1] + _ * S[2];
      if (j <= 0)
        return 0;
      if (m === 4 || Math.abs(j - a) < 2e-3)
        return S[0] > 100.01 || S[1] > 100.01 || S[2] > 100.01 ? 0 : Ot(S);
      n = n - (j - a) * n / (2 * j);
    }
    return 0;
  }
  /**
   * Finds an sRGB color with the given hue, chroma, and L*, if
   * possible.
   *
   * @param hueDegrees The desired hue, in degrees.
   * @param chroma The desired chroma.
   * @param lstar The desired L*.
   * @return A hexadecimal representing the sRGB color. The color
   * has sufficiently close hue, chroma, and L* to the desired
   * values, if possible; otherwise, the hue and L* will be
   * sufficiently close, and chroma will be maximized.
   */
  static solveToInt(e, r, a) {
    if (r < 1e-4 || a < 1e-4 || a > 99.9999)
      return fe(a);
    e = Tt(e);
    const n = e / 180 * Math.PI, o = K(a), s = h.findResultByJ(n, r, o);
    if (s !== 0)
      return s;
    const c = h.bisectToLimit(o, n);
    return Ot(c);
  }
  /**
   * Finds an sRGB color with the given hue, chroma, and L*, if
   * possible.
   *
   * @param hueDegrees The desired hue, in degrees.
   * @param chroma The desired chroma.
   * @param lstar The desired L*.
   * @return An CAM16 object representing the sRGB color. The color
   * has sufficiently close hue, chroma, and L* to the desired
   * values, if possible; otherwise, the hue and L* will be
   * sufficiently close, and chroma will be maximized.
   */
  static solveToCam(e, r, a) {
    return $.fromInt(h.solveToInt(e, r, a));
  }
}
h.SCALED_DISCOUNT_FROM_LINRGB = [
  [
    0.001200833568784504,
    0.002389694492170889,
    2795742885861124e-19
  ],
  [
    5891086651375999e-19,
    0.0029785502573438758,
    3270666104008398e-19
  ],
  [
    10146692491640572e-20,
    5364214359186694e-19,
    0.0032979401770712076
  ]
];
h.LINRGB_FROM_SCALED_DISCOUNT = [
  [
    1373.2198709594231,
    -1100.4251190754821,
    -7.278681089101213
  ],
  [
    -271.815969077903,
    559.6580465940733,
    -32.46047482791194
  ],
  [
    1.9622899599665666,
    -57.173814538844006,
    308.7233197812385
  ]
];
h.Y_FROM_LINRGB = [0.2126, 0.7152, 0.0722];
h.CRITICAL_PLANES = [
  0.015176349177441876,
  0.045529047532325624,
  0.07588174588720938,
  0.10623444424209313,
  0.13658714259697685,
  0.16693984095186062,
  0.19729253930674434,
  0.2276452376616281,
  0.2579979360165119,
  0.28835063437139563,
  0.3188300904430532,
  0.350925934958123,
  0.3848314933096426,
  0.42057480301049466,
  0.458183274052838,
  0.4976837250274023,
  0.5391024159806381,
  0.5824650784040898,
  0.6277969426914107,
  0.6751227633498623,
  0.7244668422128921,
  0.775853049866786,
  0.829304845476233,
  0.8848452951698498,
  0.942497089126609,
  1.0022825574869039,
  1.0642236851973577,
  1.1283421258858297,
  1.1946592148522128,
  1.2631959812511864,
  1.3339731595349034,
  1.407011200216447,
  1.4823302800086415,
  1.5599503113873272,
  1.6398909516233677,
  1.7221716113234105,
  1.8068114625156377,
  1.8938294463134073,
  1.9832442801866852,
  2.075074464868551,
  2.1693382909216234,
  2.2660538449872063,
  2.36523901573795,
  2.4669114995532007,
  2.5710888059345764,
  2.6777882626779785,
  2.7870270208169257,
  2.898822059350997,
  3.0131901897720907,
  3.1301480604002863,
  3.2497121605402226,
  3.3718988244681087,
  3.4967242352587946,
  3.624204428461639,
  3.754355295633311,
  3.887192587735158,
  4.022731918402185,
  4.160988767090289,
  4.301978482107941,
  4.445716283538092,
  4.592217266055746,
  4.741496401646282,
  4.893568542229298,
  5.048448422192488,
  5.20615066083972,
  5.3666897647573375,
  5.5300801301023865,
  5.696336044816294,
  5.865471690767354,
  6.037501145825082,
  6.212438385869475,
  6.390297286737924,
  6.571091626112461,
  6.7548350853498045,
  6.941541251256611,
  7.131223617812143,
  7.323895587840543,
  7.5195704746346665,
  7.7182615035334345,
  7.919981813454504,
  8.124744458384042,
  8.332562408825165,
  8.543448553206703,
  8.757415699253682,
  8.974476575321063,
  9.194643831691977,
  9.417930041841839,
  9.644347703669503,
  9.873909240696694,
  10.106627003236781,
  10.342513269534024,
  10.58158024687427,
  10.8238400726681,
  11.069304815507364,
  11.317986476196008,
  11.569896988756009,
  11.825048221409341,
  12.083451977536606,
  12.345119996613247,
  12.610063955123938,
  12.878295467455942,
  13.149826086772048,
  13.42466730586372,
  13.702830557985108,
  13.984327217668513,
  14.269168601521828,
  14.55736596900856,
  14.848930523210871,
  15.143873411576273,
  15.44220572664832,
  15.743938506781891,
  16.04908273684337,
  16.35764934889634,
  16.66964922287304,
  16.985093187232053,
  17.30399201960269,
  17.62635644741625,
  17.95219714852476,
  18.281524751807332,
  18.614349837764564,
  18.95068293910138,
  19.290534541298456,
  19.633915083172692,
  19.98083495742689,
  20.331304511189067,
  20.685334046541502,
  21.042933821039977,
  21.404114048223256,
  21.76888489811322,
  22.137256497705877,
  22.50923893145328,
  22.884842241736916,
  23.264076429332462,
  23.6469514538663,
  24.033477234264016,
  24.42366364919083,
  24.817520537484558,
  25.21505769858089,
  25.61628489293138,
  26.021211842414342,
  26.429848230738664,
  26.842203703840827,
  27.258287870275353,
  27.678110301598522,
  28.10168053274597,
  28.529008062403893,
  28.96010235337422,
  29.39497283293396,
  29.83362889318845,
  30.276079891419332,
  30.722335150426627,
  31.172403958865512,
  31.62629557157785,
  32.08401920991837,
  32.54558406207592,
  33.010999283389665,
  33.4802739966603,
  33.953417292456834,
  34.430438229418264,
  34.911345834551085,
  35.39614910352207,
  35.88485700094671,
  36.37747846067349,
  36.87402238606382,
  37.37449765026789,
  37.87891309649659,
  38.38727753828926,
  38.89959975977785,
  39.41588851594697,
  39.93615253289054,
  40.460400508064545,
  40.98864111053629,
  41.520882981230194,
  42.05713473317016,
  42.597404951718396,
  43.141702194811224,
  43.6900349931913,
  44.24241185063697,
  44.798841244188324,
  45.35933162437017,
  45.92389141541209,
  46.49252901546552,
  47.065252796817916,
  47.64207110610409,
  48.22299226451468,
  48.808024568002054,
  49.3971762874833,
  49.9904556690408,
  50.587870934119984,
  51.189430279724725,
  51.79514187861014,
  52.40501387947288,
  53.0190544071392,
  53.637271562750364,
  54.259673423945976,
  54.88626804504493,
  55.517063457223934,
  56.15206766869424,
  56.79128866487574,
  57.43473440856916,
  58.08241284012621,
  58.734331877617365,
  59.39049941699807,
  60.05092333227251,
  60.715611475655585,
  61.38457167773311,
  62.057811747619894,
  62.7353394731159,
  63.417162620860914,
  64.10328893648692,
  64.79372614476921,
  65.48848194977529,
  66.18756403501224,
  66.89098006357258,
  67.59873767827808,
  68.31084450182222,
  69.02730813691093,
  69.74813616640164,
  70.47333615344107,
  71.20291564160104,
  71.93688215501312,
  72.67524319850172,
  73.41800625771542,
  74.16517879925733,
  74.9167682708136,
  75.67278210128072,
  76.43322770089146,
  77.1981124613393,
  77.96744375590167,
  78.74122893956174,
  79.51947534912904,
  80.30219030335869,
  81.08938110306934,
  81.88105503125999,
  82.67721935322541,
  83.4778813166706,
  84.28304815182372,
  85.09272707154808,
  85.90692527145302,
  86.72564993000343,
  87.54890820862819,
  88.3767072518277,
  89.2090541872801,
  90.04595612594655,
  90.88742016217518,
  91.73345337380438,
  92.58406282226491,
  93.43925555268066,
  94.29903859396902,
  95.16341895893969,
  96.03240364439274,
  96.9059996312159,
  97.78421388448044,
  98.6670533535366,
  99.55452497210776
];
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class z {
  static from(e, r, a) {
    return new z(h.solveToInt(e, r, a));
  }
  /**
   * @param argb ARGB representation of a color.
   * @return HCT representation of a color in default viewing conditions
   */
  static fromInt(e) {
    return new z(e);
  }
  toInt() {
    return this.argb;
  }
  /**
   * A number, in degrees, representing ex. red, orange, yellow, etc.
   * Ranges from 0 <= hue < 360.
   */
  get hue() {
    return this.internalHue;
  }
  /**
   * @param newHue 0 <= newHue < 360; invalid values are corrected.
   * Chroma may decrease because chroma has a different maximum for any given
   * hue and tone.
   */
  set hue(e) {
    this.setInternalState(h.solveToInt(e, this.internalChroma, this.internalTone));
  }
  get chroma() {
    return this.internalChroma;
  }
  /**
   * @param newChroma 0 <= newChroma < ?
   * Chroma may decrease because chroma has a different maximum for any given
   * hue and tone.
   */
  set chroma(e) {
    this.setInternalState(h.solveToInt(this.internalHue, e, this.internalTone));
  }
  /** Lightness. Ranges from 0 to 100. */
  get tone() {
    return this.internalTone;
  }
  /**
   * @param newTone 0 <= newTone <= 100; invalid valids are corrected.
   * Chroma may decrease because chroma has a different maximum for any given
   * hue and tone.
   */
  set tone(e) {
    this.setInternalState(h.solveToInt(this.internalHue, this.internalChroma, e));
  }
  constructor(e) {
    this.argb = e;
    const r = $.fromInt(e);
    this.internalHue = r.hue, this.internalChroma = r.chroma, this.internalTone = Pt(e), this.argb = e;
  }
  setInternalState(e) {
    const r = $.fromInt(e);
    this.internalHue = r.hue, this.internalChroma = r.chroma, this.internalTone = Pt(e), this.argb = e;
  }
  /**
   * Translates a color into different [ViewingConditions].
   *
   * Colors change appearance. They look different with lights on versus off,
   * the same color, as in hex code, on white looks different when on black.
   * This is called color relativity, most famously explicated by Josef Albers
   * in Interaction of Color.
   *
   * In color science, color appearance models can account for this and
   * calculate the appearance of a color in different settings. HCT is based on
   * CAM16, a color appearance model, and uses it to make these calculations.
   *
   * See [ViewingConditions.make] for parameters affecting color appearance.
   */
  inViewingConditions(e) {
    const a = $.fromInt(this.toInt()).xyzInViewingConditions(e), n = $.fromXyzInViewingConditions(a[0], a[1], a[2], U.make());
    return z.from(n.hue, n.chroma, kt(a[1]));
  }
}
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class Ft {
  /**
   * Blend the design color's HCT hue towards the key color's HCT
   * hue, in a way that leaves the original color recognizable and
   * recognizably shifted towards the key color.
   *
   * @param designColor ARGB representation of an arbitrary color.
   * @param sourceColor ARGB representation of the main theme color.
   * @return The design color with a hue shifted towards the
   * system's color, a slightly warmer/cooler variant of the design
   * color's hue.
   */
  static harmonize(e, r) {
    const a = z.fromInt(e), n = z.fromInt(r), o = ne(a.hue, n.hue), s = Math.min(o * 0.5, 15), c = Tt(a.hue + s * re(a.hue, n.hue));
    return z.from(c, a.chroma, a.tone).toInt();
  }
  /**
   * Blends hue from one color into another. The chroma and tone of
   * the original color are maintained.
   *
   * @param from ARGB representation of color
   * @param to ARGB representation of color
   * @param amount how much blending to perform; 0.0 >= and <= 1.0
   * @return from, with a hue blended towards to. Chroma and tone
   * are constant.
   */
  static hctHue(e, r, a) {
    const n = Ft.cam16Ucs(e, r, a), o = $.fromInt(n), s = $.fromInt(e);
    return z.from(o.hue, s.chroma, Pt(e)).toInt();
  }
  /**
   * Blend in CAM16-UCS space.
   *
   * @param from ARGB representation of color
   * @param to ARGB representation of color
   * @param amount how much blending to perform; 0.0 >= and <= 1.0
   * @return from, blended towards to. Hue, chroma, and tone will
   * change.
   */
  static cam16Ucs(e, r, a) {
    const n = $.fromInt(e), o = $.fromInt(r), s = n.jstar, c = n.astar, u = n.bstar, f = o.jstar, l = o.astar, m = o.bstar, g = s + (f - s) * a, b = c + (l - c) * a, x = u + (m - u) * a;
    return $.fromUcs(g, b, x).toInt();
  }
}
/**
 * @license
 * Copyright 2022 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class O {
  /**
   * Returns a contrast ratio, which ranges from 1 to 21.
   *
   * @param toneA Tone between 0 and 100. Values outside will be clamped.
   * @param toneB Tone between 0 and 100. Values outside will be clamped.
   */
  static ratioOfTones(e, r) {
    return e = mt(0, 100, e), r = mt(0, 100, r), O.ratioOfYs(K(e), K(r));
  }
  static ratioOfYs(e, r) {
    const a = e > r ? e : r, n = a === r ? e : r;
    return (a + 5) / (n + 5);
  }
  /**
   * Returns a tone >= tone parameter that ensures ratio parameter.
   * Return value is between 0 and 100.
   * Returns -1 if ratio cannot be achieved with tone parameter.
   *
   * @param tone Tone return value must contrast with.
   * Range is 0 to 100. Invalid values will result in -1 being returned.
   * @param ratio Contrast ratio of return value and tone.
   * Range is 1 to 21, invalid values have undefined behavior.
   */
  static lighter(e, r) {
    if (e < 0 || e > 100)
      return -1;
    const a = K(e), n = r * (a + 5) - 5, o = O.ratioOfYs(n, a), s = Math.abs(o - r);
    if (o < r && s > 0.04)
      return -1;
    const c = kt(n) + 0.4;
    return c < 0 || c > 100 ? -1 : c;
  }
  /**
   * Returns a tone <= tone parameter that ensures ratio parameter.
   * Return value is between 0 and 100.
   * Returns -1 if ratio cannot be achieved with tone parameter.
   *
   * @param tone Tone return value must contrast with.
   * Range is 0 to 100. Invalid values will result in -1 being returned.
   * @param ratio Contrast ratio of return value and tone.
   * Range is 1 to 21, invalid values have undefined behavior.
   */
  static darker(e, r) {
    if (e < 0 || e > 100)
      return -1;
    const a = K(e), n = (a + 5) / r - 5, o = O.ratioOfYs(a, n), s = Math.abs(o - r);
    if (o < r && s > 0.04)
      return -1;
    const c = kt(n) - 0.4;
    return c < 0 || c > 100 ? -1 : c;
  }
  /**
   * Returns a tone >= tone parameter that ensures ratio parameter.
   * Return value is between 0 and 100.
   * Returns 100 if ratio cannot be achieved with tone parameter.
   *
   * This method is unsafe because the returned value is guaranteed to be in
   * bounds for tone, i.e. between 0 and 100. However, that value may not reach
   * the ratio with tone. For example, there is no color lighter than T100.
   *
   * @param tone Tone return value must contrast with.
   * Range is 0 to 100. Invalid values will result in 100 being returned.
   * @param ratio Desired contrast ratio of return value and tone parameter.
   * Range is 1 to 21, invalid values have undefined behavior.
   */
  static lighterUnsafe(e, r) {
    const a = O.lighter(e, r);
    return a < 0 ? 100 : a;
  }
  /**
   * Returns a tone >= tone parameter that ensures ratio parameter.
   * Return value is between 0 and 100.
   * Returns 100 if ratio cannot be achieved with tone parameter.
   *
   * This method is unsafe because the returned value is guaranteed to be in
   * bounds for tone, i.e. between 0 and 100. However, that value may not reach
   * the [ratio with [tone]. For example, there is no color darker than T0.
   *
   * @param tone Tone return value must contrast with.
   * Range is 0 to 100. Invalid values will result in 0 being returned.
   * @param ratio Desired contrast ratio of return value and tone parameter.
   * Range is 1 to 21, invalid values have undefined behavior.
   */
  static darkerUnsafe(e, r) {
    const a = O.darker(e, r);
    return a < 0 ? 0 : a;
  }
}
/**
 * @license
 * Copyright 2023 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class St {
  /**
   * Returns true if a color is disliked.
   *
   * @param hct A color to be judged.
   * @return Whether the color is disliked.
   *
   * Disliked is defined as a dark yellow-green that is not neutral.
   */
  static isDisliked(e) {
    const r = Math.round(e.hue) >= 90 && Math.round(e.hue) <= 111, a = Math.round(e.chroma) > 16, n = Math.round(e.tone) < 65;
    return r && a && n;
  }
  /**
   * If a color is disliked, lighten it to make it likable.
   *
   * @param hct A color to be judged.
   * @return A new color if the original color is disliked, or the original
   *   color if it is acceptable.
   */
  static fixIfDisliked(e) {
    return St.isDisliked(e) ? z.from(e.hue, e.chroma, 70) : e;
  }
}
/**
 * @license
 * Copyright 2022 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class p {
  /**
   * Create a DynamicColor defined by a TonalPalette and HCT tone.
   *
   * @param args Functions with DynamicScheme as input. Must provide a palette
   * and tone. May provide a background DynamicColor and ToneDeltaConstraint.
   */
  static fromPalette(e) {
    return new p(e.name ?? "", e.palette, e.tone, e.isBackground ?? !1, e.background, e.secondBackground, e.contrastCurve, e.toneDeltaPair);
  }
  /**
   * The base constructor for DynamicColor.
   *
   * _Strongly_ prefer using one of the convenience constructors. This class is
   * arguably too flexible to ensure it can support any scenario. Functional
   * arguments allow  overriding without risks that come with subclasses.
   *
   * For example, the default behavior of adjust tone at max contrast
   * to be at a 7.0 ratio with its background is principled and
   * matches accessibility guidance. That does not mean it's the desired
   * approach for _every_ design system, and every color pairing,
   * always, in every case.
   *
   * @param name The name of the dynamic color. Defaults to empty.
   * @param palette Function that provides a TonalPalette given
   * DynamicScheme. A TonalPalette is defined by a hue and chroma, so this
   * replaces the need to specify hue/chroma. By providing a tonal palette, when
   * contrast adjustments are made, intended chroma can be preserved.
   * @param tone Function that provides a tone, given a DynamicScheme.
   * @param isBackground Whether this dynamic color is a background, with
   * some other color as the foreground. Defaults to false.
   * @param background The background of the dynamic color (as a function of a
   *     `DynamicScheme`), if it exists.
   * @param secondBackground A second background of the dynamic color (as a
   *     function of a `DynamicScheme`), if it
   * exists.
   * @param contrastCurve A `ContrastCurve` object specifying how its contrast
   * against its background should behave in various contrast levels options.
   * @param toneDeltaPair A `ToneDeltaPair` object specifying a tone delta
   * constraint between two colors. One of them must be the color being
   * constructed.
   */
  constructor(e, r, a, n, o, s, c, u) {
    if (this.name = e, this.palette = r, this.tone = a, this.isBackground = n, this.background = o, this.secondBackground = s, this.contrastCurve = c, this.toneDeltaPair = u, this.hctCache = /* @__PURE__ */ new Map(), !o && s)
      throw new Error(`Color ${e} has secondBackgrounddefined, but background is not defined.`);
    if (!o && c)
      throw new Error(`Color ${e} has contrastCurvedefined, but background is not defined.`);
    if (o && !c)
      throw new Error(`Color ${e} has backgrounddefined, but contrastCurve is not defined.`);
  }
  /**
   * Return a ARGB integer (i.e. a hex code).
   *
   * @param scheme Defines the conditions of the user interface, for example,
   * whether or not it is dark mode or light mode, and what the desired
   * contrast level is.
   */
  getArgb(e) {
    return this.getHct(e).toInt();
  }
  /**
   * Return a color, expressed in the HCT color space, that this
   * DynamicColor is under the conditions in scheme.
   *
   * @param scheme Defines the conditions of the user interface, for example,
   * whether or not it is dark mode or light mode, and what the desired
   * contrast level is.
   */
  getHct(e) {
    const r = this.hctCache.get(e);
    if (r != null)
      return r;
    const a = this.getTone(e), n = this.palette(e).getHct(a);
    return this.hctCache.size > 4 && this.hctCache.clear(), this.hctCache.set(e, n), n;
  }
  /**
   * Return a tone, T in the HCT color space, that this DynamicColor is under
   * the conditions in scheme.
   *
   * @param scheme Defines the conditions of the user interface, for example,
   * whether or not it is dark mode or light mode, and what the desired
   * contrast level is.
   */
  getTone(e) {
    const r = e.contrastLevel < 0;
    if (this.toneDeltaPair) {
      const a = this.toneDeltaPair(e), n = a.roleA, o = a.roleB, s = a.delta, c = a.polarity, u = a.stayTogether, l = this.background(e).getTone(e), m = c === "nearer" || c === "lighter" && !e.isDark || c === "darker" && e.isDark, g = m ? n : o, b = m ? o : n, x = this.name === g.name, y = e.isDark ? 1 : -1, M = g.contrastCurve.getContrast(e.contrastLevel), F = b.contrastCurve.getContrast(e.contrastLevel), D = g.tone(e);
      let k = O.ratioOfTones(l, D) >= M ? D : p.foregroundTone(l, M);
      const V = b.tone(e);
      let P = O.ratioOfTones(l, V) >= F ? V : p.foregroundTone(l, F);
      return r && (k = p.foregroundTone(l, M), P = p.foregroundTone(l, F)), (P - k) * y >= s || (P = mt(0, 100, k + s * y), (P - k) * y >= s || (k = mt(0, 100, P - s * y))), 50 <= k && k < 60 ? y > 0 ? (k = 60, P = Math.max(P, k + s * y)) : (k = 49, P = Math.min(P, k + s * y)) : 50 <= P && P < 60 && (u ? y > 0 ? (k = 60, P = Math.max(P, k + s * y)) : (k = 49, P = Math.min(P, k + s * y)) : y > 0 ? P = 60 : P = 49), x ? k : P;
    } else {
      let a = this.tone(e);
      if (this.background == null)
        return a;
      const n = this.background(e).getTone(e), o = this.contrastCurve.getContrast(e.contrastLevel);
      if (O.ratioOfTones(n, a) >= o || (a = p.foregroundTone(n, o)), r && (a = p.foregroundTone(n, o)), this.isBackground && 50 <= a && a < 60 && (O.ratioOfTones(49, n) >= o ? a = 49 : a = 60), this.secondBackground) {
        const [s, c] = [this.background, this.secondBackground], [u, f] = [s(e).getTone(e), c(e).getTone(e)], [l, m] = [Math.max(u, f), Math.min(u, f)];
        if (O.ratioOfTones(l, a) >= o && O.ratioOfTones(m, a) >= o)
          return a;
        const g = O.lighter(l, o), b = O.darker(m, o), x = [];
        return g !== -1 && x.push(g), b !== -1 && x.push(b), p.tonePrefersLightForeground(u) || p.tonePrefersLightForeground(f) ? g < 0 ? 100 : g : x.length === 1 ? x[0] : b < 0 ? 0 : b;
      }
      return a;
    }
  }
  /**
   * Given a background tone, find a foreground tone, while ensuring they reach
   * a contrast ratio that is as close to [ratio] as possible.
   *
   * @param bgTone Tone in HCT. Range is 0 to 100, undefined behavior when it
   *     falls outside that range.
   * @param ratio The contrast ratio desired between bgTone and the return
   *     value.
   */
  static foregroundTone(e, r) {
    const a = O.lighterUnsafe(e, r), n = O.darkerUnsafe(e, r), o = O.ratioOfTones(a, e), s = O.ratioOfTones(n, e);
    if (p.tonePrefersLightForeground(e)) {
      const u = Math.abs(o - s) < 0.1 && o < r && s < r;
      return o >= r || o >= s || u ? a : n;
    } else
      return s >= r || s >= o ? n : a;
  }
  /**
   * Returns whether [tone] prefers a light foreground.
   *
   * People prefer white foregrounds on ~T60-70. Observed over time, and also
   * by Andrew Somers during research for APCA.
   *
   * T60 used as to create the smallest discontinuity possible when skipping
   * down to T49 in order to ensure light foregrounds.
   * Since `tertiaryContainer` in dark monochrome scheme requires a tone of
   * 60, it should not be adjusted. Therefore, 60 is excluded here.
   */
  static tonePrefersLightForeground(e) {
    return Math.round(e) < 60;
  }
  /**
   * Returns whether [tone] can reach a contrast ratio of 4.5 with a lighter
   * color.
   */
  static toneAllowsLightForeground(e) {
    return Math.round(e) <= 49;
  }
  /**
   * Adjust a tone such that white has 4.5 contrast, if the tone is
   * reasonably close to supporting it.
   */
  static enableLightForeground(e) {
    return p.tonePrefersLightForeground(e) && !p.toneAllowsLightForeground(e) ? 49 : e;
  }
}
/**
 * @license
 * Copyright 2022 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
var it;
(function(t) {
  t[t.MONOCHROME = 0] = "MONOCHROME", t[t.NEUTRAL = 1] = "NEUTRAL", t[t.TONAL_SPOT = 2] = "TONAL_SPOT", t[t.VIBRANT = 3] = "VIBRANT", t[t.EXPRESSIVE = 4] = "EXPRESSIVE", t[t.FIDELITY = 5] = "FIDELITY", t[t.CONTENT = 6] = "CONTENT", t[t.RAINBOW = 7] = "RAINBOW", t[t.FRUIT_SALAD = 8] = "FRUIT_SALAD";
})(it || (it = {}));
/**
 * @license
 * Copyright 2023 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class C {
  /**
   * Creates a `ContrastCurve` object.
   *
   * @param low Contrast requirement for contrast level -1.0
   * @param normal Contrast requirement for contrast level 0.0
   * @param medium Contrast requirement for contrast level 0.5
   * @param high Contrast requirement for contrast level 1.0
   */
  constructor(e, r, a, n) {
    this.low = e, this.normal = r, this.medium = a, this.high = n;
  }
  /**
   * Returns the contrast ratio at a given contrast level.
   *
   * @param contrastLevel The contrast level. 0.0 is the default (normal);
   * -1.0 is the lowest; 1.0 is the highest.
   * @return The contrast ratio, a number between 1.0 and 21.0.
   */
  getContrast(e) {
    return e <= -1 ? this.low : e < 0 ? st(this.low, this.normal, (e - -1) / 1) : e < 0.5 ? st(this.normal, this.medium, (e - 0) / 0.5) : e < 1 ? st(this.medium, this.high, (e - 0.5) / 0.5) : this.high;
  }
}
/**
 * @license
 * Copyright 2023 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class N {
  /**
   * Documents a constraint in tone distance between two DynamicColors.
   *
   * The polarity is an adjective that describes "A", compared to "B".
   *
   * For instance, ToneDeltaPair(A, B, 15, 'darker', stayTogether) states that
   * A's tone should be at least 15 darker than B's.
   *
   * 'nearer' and 'farther' describes closeness to the surface roles. For
   * instance, ToneDeltaPair(A, B, 10, 'nearer', stayTogether) states that A
   * should be 10 lighter than B in light mode, and 10 darker than B in dark
   * mode.
   *
   * @param roleA The first role in a pair.
   * @param roleB The second role in a pair.
   * @param delta Required difference between tones. Absolute value, negative
   * values have undefined behavior.
   * @param polarity The relative relation between tones of roleA and roleB,
   * as described above.
   * @param stayTogether Whether these two roles should stay on the same side of
   * the "awkward zone" (T50-59). This is necessary for certain cases where
   * one role has two backgrounds.
   */
  constructor(e, r, a, n, o) {
    this.roleA = e, this.roleB = r, this.delta = a, this.polarity = n, this.stayTogether = o;
  }
}
/**
 * @license
 * Copyright 2022 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function ot(t) {
  return t.variant === it.FIDELITY || t.variant === it.CONTENT;
}
function I(t) {
  return t.variant === it.MONOCHROME;
}
function he(t, e, r, a) {
  let n = r, o = z.from(t, e, r);
  if (o.chroma < e) {
    let s = o.chroma;
    for (; o.chroma < e; ) {
      n += a ? -1 : 1;
      const c = z.from(t, e, n);
      if (s > c.chroma || Math.abs(c.chroma - e) < 0.4)
        break;
      const u = Math.abs(c.chroma - e), f = Math.abs(o.chroma - e);
      u < f && (o = c), s = Math.max(s, c.chroma);
    }
  }
  return n;
}
function me(t) {
  return U.make(
    /*whitePoint=*/
    void 0,
    /*adaptingLuminance=*/
    void 0,
    /*backgroundLstar=*/
    t.isDark ? 30 : 80,
    /*surround=*/
    void 0,
    /*discountingIlluminant=*/
    void 0
  );
}
function Rt(t, e) {
  const r = t.inViewingConditions(me(e));
  return p.tonePrefersLightForeground(t.tone) && !p.toneAllowsLightForeground(r.tone) ? p.enableLightForeground(t.tone) : p.enableLightForeground(r.tone);
}
class i {
  static highestSurface(e) {
    return e.isDark ? i.surfaceBright : i.surfaceDim;
  }
}
i.contentAccentToneDelta = 15;
i.primaryPaletteKeyColor = p.fromPalette({
  name: "primary_palette_key_color",
  palette: (t) => t.primaryPalette,
  tone: (t) => t.primaryPalette.keyColor.tone
});
i.secondaryPaletteKeyColor = p.fromPalette({
  name: "secondary_palette_key_color",
  palette: (t) => t.secondaryPalette,
  tone: (t) => t.secondaryPalette.keyColor.tone
});
i.tertiaryPaletteKeyColor = p.fromPalette({
  name: "tertiary_palette_key_color",
  palette: (t) => t.tertiaryPalette,
  tone: (t) => t.tertiaryPalette.keyColor.tone
});
i.neutralPaletteKeyColor = p.fromPalette({
  name: "neutral_palette_key_color",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.neutralPalette.keyColor.tone
});
i.neutralVariantPaletteKeyColor = p.fromPalette({
  name: "neutral_variant_palette_key_color",
  palette: (t) => t.neutralVariantPalette,
  tone: (t) => t.neutralVariantPalette.keyColor.tone
});
i.background = p.fromPalette({
  name: "background",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 6 : 98,
  isBackground: !0
});
i.onBackground = p.fromPalette({
  name: "on_background",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 90 : 10,
  background: (t) => i.background,
  contrastCurve: new C(3, 3, 4.5, 7)
});
i.surface = p.fromPalette({
  name: "surface",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 6 : 98,
  isBackground: !0
});
i.surfaceDim = p.fromPalette({
  name: "surface_dim",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 6 : 87,
  isBackground: !0
});
i.surfaceBright = p.fromPalette({
  name: "surface_bright",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 24 : 98,
  isBackground: !0
});
i.surfaceContainerLowest = p.fromPalette({
  name: "surface_container_lowest",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 4 : 100,
  isBackground: !0
});
i.surfaceContainerLow = p.fromPalette({
  name: "surface_container_low",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 10 : 96,
  isBackground: !0
});
i.surfaceContainer = p.fromPalette({
  name: "surface_container",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 12 : 94,
  isBackground: !0
});
i.surfaceContainerHigh = p.fromPalette({
  name: "surface_container_high",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 17 : 92,
  isBackground: !0
});
i.surfaceContainerHighest = p.fromPalette({
  name: "surface_container_highest",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 22 : 90,
  isBackground: !0
});
i.onSurface = p.fromPalette({
  name: "on_surface",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 90 : 10,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.surfaceVariant = p.fromPalette({
  name: "surface_variant",
  palette: (t) => t.neutralVariantPalette,
  tone: (t) => t.isDark ? 30 : 90,
  isBackground: !0
});
i.onSurfaceVariant = p.fromPalette({
  name: "on_surface_variant",
  palette: (t) => t.neutralVariantPalette,
  tone: (t) => t.isDark ? 80 : 30,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(3, 4.5, 7, 11)
});
i.inverseSurface = p.fromPalette({
  name: "inverse_surface",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 90 : 20
});
i.inverseOnSurface = p.fromPalette({
  name: "inverse_on_surface",
  palette: (t) => t.neutralPalette,
  tone: (t) => t.isDark ? 20 : 95,
  background: (t) => i.inverseSurface,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.outline = p.fromPalette({
  name: "outline",
  palette: (t) => t.neutralVariantPalette,
  tone: (t) => t.isDark ? 60 : 50,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1.5, 3, 4.5, 7)
});
i.outlineVariant = p.fromPalette({
  name: "outline_variant",
  palette: (t) => t.neutralVariantPalette,
  tone: (t) => t.isDark ? 30 : 80,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7)
});
i.shadow = p.fromPalette({
  name: "shadow",
  palette: (t) => t.neutralPalette,
  tone: (t) => 0
});
i.scrim = p.fromPalette({
  name: "scrim",
  palette: (t) => t.neutralPalette,
  tone: (t) => 0
});
i.surfaceTint = p.fromPalette({
  name: "surface_tint",
  palette: (t) => t.primaryPalette,
  tone: (t) => t.isDark ? 80 : 40,
  isBackground: !0
});
i.primary = p.fromPalette({
  name: "primary",
  palette: (t) => t.primaryPalette,
  tone: (t) => I(t) ? t.isDark ? 100 : 0 : t.isDark ? 80 : 40,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(3, 4.5, 7, 11),
  toneDeltaPair: (t) => new N(i.primaryContainer, i.primary, 15, "nearer", !1)
});
i.onPrimary = p.fromPalette({
  name: "on_primary",
  palette: (t) => t.primaryPalette,
  tone: (t) => I(t) ? t.isDark ? 10 : 90 : t.isDark ? 20 : 100,
  background: (t) => i.primary,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.primaryContainer = p.fromPalette({
  name: "primary_container",
  palette: (t) => t.primaryPalette,
  tone: (t) => ot(t) ? Rt(t.sourceColorHct, t) : I(t) ? t.isDark ? 85 : 25 : t.isDark ? 30 : 90,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.primaryContainer, i.primary, 15, "nearer", !1)
});
i.onPrimaryContainer = p.fromPalette({
  name: "on_primary_container",
  palette: (t) => t.primaryPalette,
  tone: (t) => ot(t) ? p.foregroundTone(i.primaryContainer.tone(t), 4.5) : I(t) ? t.isDark ? 0 : 100 : t.isDark ? 90 : 10,
  background: (t) => i.primaryContainer,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.inversePrimary = p.fromPalette({
  name: "inverse_primary",
  palette: (t) => t.primaryPalette,
  tone: (t) => t.isDark ? 40 : 80,
  background: (t) => i.inverseSurface,
  contrastCurve: new C(3, 4.5, 7, 11)
});
i.secondary = p.fromPalette({
  name: "secondary",
  palette: (t) => t.secondaryPalette,
  tone: (t) => t.isDark ? 80 : 40,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(3, 4.5, 7, 11),
  toneDeltaPair: (t) => new N(i.secondaryContainer, i.secondary, 15, "nearer", !1)
});
i.onSecondary = p.fromPalette({
  name: "on_secondary",
  palette: (t) => t.secondaryPalette,
  tone: (t) => I(t) ? t.isDark ? 10 : 100 : t.isDark ? 20 : 100,
  background: (t) => i.secondary,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.secondaryContainer = p.fromPalette({
  name: "secondary_container",
  palette: (t) => t.secondaryPalette,
  tone: (t) => {
    const e = t.isDark ? 30 : 90;
    if (I(t))
      return t.isDark ? 30 : 85;
    if (!ot(t))
      return e;
    let r = he(t.secondaryPalette.hue, t.secondaryPalette.chroma, e, !t.isDark);
    return r = Rt(t.secondaryPalette.getHct(r), t), r;
  },
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.secondaryContainer, i.secondary, 15, "nearer", !1)
});
i.onSecondaryContainer = p.fromPalette({
  name: "on_secondary_container",
  palette: (t) => t.secondaryPalette,
  tone: (t) => ot(t) ? p.foregroundTone(i.secondaryContainer.tone(t), 4.5) : t.isDark ? 90 : 10,
  background: (t) => i.secondaryContainer,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.tertiary = p.fromPalette({
  name: "tertiary",
  palette: (t) => t.tertiaryPalette,
  tone: (t) => I(t) ? t.isDark ? 90 : 25 : t.isDark ? 80 : 40,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(3, 4.5, 7, 11),
  toneDeltaPair: (t) => new N(i.tertiaryContainer, i.tertiary, 15, "nearer", !1)
});
i.onTertiary = p.fromPalette({
  name: "on_tertiary",
  palette: (t) => t.tertiaryPalette,
  tone: (t) => I(t) ? t.isDark ? 10 : 90 : t.isDark ? 20 : 100,
  background: (t) => i.tertiary,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.tertiaryContainer = p.fromPalette({
  name: "tertiary_container",
  palette: (t) => t.tertiaryPalette,
  tone: (t) => {
    if (I(t))
      return t.isDark ? 60 : 49;
    if (!ot(t))
      return t.isDark ? 30 : 90;
    const e = Rt(t.tertiaryPalette.getHct(t.sourceColorHct.tone), t), r = t.tertiaryPalette.getHct(e);
    return St.fixIfDisliked(r).tone;
  },
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.tertiaryContainer, i.tertiary, 15, "nearer", !1)
});
i.onTertiaryContainer = p.fromPalette({
  name: "on_tertiary_container",
  palette: (t) => t.tertiaryPalette,
  tone: (t) => I(t) ? t.isDark ? 0 : 100 : ot(t) ? p.foregroundTone(i.tertiaryContainer.tone(t), 4.5) : t.isDark ? 90 : 10,
  background: (t) => i.tertiaryContainer,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.error = p.fromPalette({
  name: "error",
  palette: (t) => t.errorPalette,
  tone: (t) => t.isDark ? 80 : 40,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(3, 4.5, 7, 11),
  toneDeltaPair: (t) => new N(i.errorContainer, i.error, 15, "nearer", !1)
});
i.onError = p.fromPalette({
  name: "on_error",
  palette: (t) => t.errorPalette,
  tone: (t) => t.isDark ? 20 : 100,
  background: (t) => i.error,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.errorContainer = p.fromPalette({
  name: "error_container",
  palette: (t) => t.errorPalette,
  tone: (t) => t.isDark ? 30 : 90,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.errorContainer, i.error, 15, "nearer", !1)
});
i.onErrorContainer = p.fromPalette({
  name: "on_error_container",
  palette: (t) => t.errorPalette,
  tone: (t) => t.isDark ? 90 : 10,
  background: (t) => i.errorContainer,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.primaryFixed = p.fromPalette({
  name: "primary_fixed",
  palette: (t) => t.primaryPalette,
  tone: (t) => I(t) ? 40 : 90,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.primaryFixed, i.primaryFixedDim, 10, "lighter", !0)
});
i.primaryFixedDim = p.fromPalette({
  name: "primary_fixed_dim",
  palette: (t) => t.primaryPalette,
  tone: (t) => I(t) ? 30 : 80,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.primaryFixed, i.primaryFixedDim, 10, "lighter", !0)
});
i.onPrimaryFixed = p.fromPalette({
  name: "on_primary_fixed",
  palette: (t) => t.primaryPalette,
  tone: (t) => I(t) ? 100 : 10,
  background: (t) => i.primaryFixedDim,
  secondBackground: (t) => i.primaryFixed,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.onPrimaryFixedVariant = p.fromPalette({
  name: "on_primary_fixed_variant",
  palette: (t) => t.primaryPalette,
  tone: (t) => I(t) ? 90 : 30,
  background: (t) => i.primaryFixedDim,
  secondBackground: (t) => i.primaryFixed,
  contrastCurve: new C(3, 4.5, 7, 11)
});
i.secondaryFixed = p.fromPalette({
  name: "secondary_fixed",
  palette: (t) => t.secondaryPalette,
  tone: (t) => I(t) ? 80 : 90,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.secondaryFixed, i.secondaryFixedDim, 10, "lighter", !0)
});
i.secondaryFixedDim = p.fromPalette({
  name: "secondary_fixed_dim",
  palette: (t) => t.secondaryPalette,
  tone: (t) => I(t) ? 70 : 80,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.secondaryFixed, i.secondaryFixedDim, 10, "lighter", !0)
});
i.onSecondaryFixed = p.fromPalette({
  name: "on_secondary_fixed",
  palette: (t) => t.secondaryPalette,
  tone: (t) => 10,
  background: (t) => i.secondaryFixedDim,
  secondBackground: (t) => i.secondaryFixed,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.onSecondaryFixedVariant = p.fromPalette({
  name: "on_secondary_fixed_variant",
  palette: (t) => t.secondaryPalette,
  tone: (t) => I(t) ? 25 : 30,
  background: (t) => i.secondaryFixedDim,
  secondBackground: (t) => i.secondaryFixed,
  contrastCurve: new C(3, 4.5, 7, 11)
});
i.tertiaryFixed = p.fromPalette({
  name: "tertiary_fixed",
  palette: (t) => t.tertiaryPalette,
  tone: (t) => I(t) ? 40 : 90,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.tertiaryFixed, i.tertiaryFixedDim, 10, "lighter", !0)
});
i.tertiaryFixedDim = p.fromPalette({
  name: "tertiary_fixed_dim",
  palette: (t) => t.tertiaryPalette,
  tone: (t) => I(t) ? 30 : 80,
  isBackground: !0,
  background: (t) => i.highestSurface(t),
  contrastCurve: new C(1, 1, 3, 7),
  toneDeltaPair: (t) => new N(i.tertiaryFixed, i.tertiaryFixedDim, 10, "lighter", !0)
});
i.onTertiaryFixed = p.fromPalette({
  name: "on_tertiary_fixed",
  palette: (t) => t.tertiaryPalette,
  tone: (t) => I(t) ? 100 : 10,
  background: (t) => i.tertiaryFixedDim,
  secondBackground: (t) => i.tertiaryFixed,
  contrastCurve: new C(4.5, 7, 11, 21)
});
i.onTertiaryFixedVariant = p.fromPalette({
  name: "on_tertiary_fixed_variant",
  palette: (t) => t.tertiaryPalette,
  tone: (t) => I(t) ? 90 : 30,
  background: (t) => i.tertiaryFixedDim,
  secondBackground: (t) => i.tertiaryFixed,
  contrastCurve: new C(3, 4.5, 7, 11)
});
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class E {
  /**
   * @param argb ARGB representation of a color
   * @return Tones matching that color's hue and chroma.
   */
  static fromInt(e) {
    const r = z.fromInt(e);
    return E.fromHct(r);
  }
  /**
   * @param hct Hct
   * @return Tones matching that color's hue and chroma.
   */
  static fromHct(e) {
    return new E(e.hue, e.chroma, e);
  }
  /**
   * @param hue HCT hue
   * @param chroma HCT chroma
   * @return Tones matching hue and chroma.
   */
  static fromHueAndChroma(e, r) {
    return new E(e, r, E.createKeyColor(e, r));
  }
  constructor(e, r, a) {
    this.hue = e, this.chroma = r, this.keyColor = a, this.cache = /* @__PURE__ */ new Map();
  }
  static createKeyColor(e, r) {
    let n = z.from(e, r, 50), o = Math.abs(n.chroma - r);
    for (let s = 1; s < 50; s += 1) {
      if (Math.round(r) === Math.round(n.chroma))
        return n;
      const c = z.from(e, r, 50 + s), u = Math.abs(c.chroma - r);
      u < o && (o = u, n = c);
      const f = z.from(e, r, 50 - s), l = Math.abs(f.chroma - r);
      l < o && (o = l, n = f);
    }
    return n;
  }
  /**
   * @param tone HCT tone, measured from 0 to 100.
   * @return ARGB representation of a color with that tone.
   */
  tone(e) {
    let r = this.cache.get(e);
    return r === void 0 && (r = z.from(this.hue, this.chroma, e).toInt(), this.cache.set(e, r)), r;
  }
  /**
   * @param tone HCT tone.
   * @return HCT representation of a color with that tone.
   */
  getHct(e) {
    return z.fromInt(this.tone(e));
  }
}
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class R {
  /**
   * @param argb ARGB representation of a color
   */
  static of(e) {
    return new R(e, !1);
  }
  /**
   * @param argb ARGB representation of a color
   */
  static contentOf(e) {
    return new R(e, !0);
  }
  /**
   * Create a [CorePalette] from a set of colors
   */
  static fromColors(e) {
    return R.createPaletteFromColors(!1, e);
  }
  /**
   * Create a content [CorePalette] from a set of colors
   */
  static contentFromColors(e) {
    return R.createPaletteFromColors(!0, e);
  }
  static createPaletteFromColors(e, r) {
    const a = new R(r.primary, e);
    if (r.secondary) {
      const n = new R(r.secondary, e);
      a.a2 = n.a1;
    }
    if (r.tertiary) {
      const n = new R(r.tertiary, e);
      a.a3 = n.a1;
    }
    if (r.error) {
      const n = new R(r.error, e);
      a.error = n.a1;
    }
    if (r.neutral) {
      const n = new R(r.neutral, e);
      a.n1 = n.n1;
    }
    if (r.neutralVariant) {
      const n = new R(r.neutralVariant, e);
      a.n2 = n.n2;
    }
    return a;
  }
  constructor(e, r) {
    const a = z.fromInt(e), n = a.hue, o = a.chroma;
    r ? (this.a1 = E.fromHueAndChroma(n, o), this.a2 = E.fromHueAndChroma(n, o / 3), this.a3 = E.fromHueAndChroma(n + 60, o / 2), this.n1 = E.fromHueAndChroma(n, Math.min(o / 12, 4)), this.n2 = E.fromHueAndChroma(n, Math.min(o / 6, 8))) : (this.a1 = E.fromHueAndChroma(n, Math.max(48, o)), this.a2 = E.fromHueAndChroma(n, 16), this.a3 = E.fromHueAndChroma(n + 60, 24), this.n1 = E.fromHueAndChroma(n, 4), this.n2 = E.fromHueAndChroma(n, 8)), this.error = E.fromHueAndChroma(25, 84);
  }
}
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
class J {
  get primary() {
    return this.props.primary;
  }
  get onPrimary() {
    return this.props.onPrimary;
  }
  get primaryContainer() {
    return this.props.primaryContainer;
  }
  get onPrimaryContainer() {
    return this.props.onPrimaryContainer;
  }
  get secondary() {
    return this.props.secondary;
  }
  get onSecondary() {
    return this.props.onSecondary;
  }
  get secondaryContainer() {
    return this.props.secondaryContainer;
  }
  get onSecondaryContainer() {
    return this.props.onSecondaryContainer;
  }
  get tertiary() {
    return this.props.tertiary;
  }
  get onTertiary() {
    return this.props.onTertiary;
  }
  get tertiaryContainer() {
    return this.props.tertiaryContainer;
  }
  get onTertiaryContainer() {
    return this.props.onTertiaryContainer;
  }
  get error() {
    return this.props.error;
  }
  get onError() {
    return this.props.onError;
  }
  get errorContainer() {
    return this.props.errorContainer;
  }
  get onErrorContainer() {
    return this.props.onErrorContainer;
  }
  get background() {
    return this.props.background;
  }
  get onBackground() {
    return this.props.onBackground;
  }
  get surface() {
    return this.props.surface;
  }
  get onSurface() {
    return this.props.onSurface;
  }
  get surfaceVariant() {
    return this.props.surfaceVariant;
  }
  get onSurfaceVariant() {
    return this.props.onSurfaceVariant;
  }
  get outline() {
    return this.props.outline;
  }
  get outlineVariant() {
    return this.props.outlineVariant;
  }
  get shadow() {
    return this.props.shadow;
  }
  get scrim() {
    return this.props.scrim;
  }
  get inverseSurface() {
    return this.props.inverseSurface;
  }
  get inverseOnSurface() {
    return this.props.inverseOnSurface;
  }
  get inversePrimary() {
    return this.props.inversePrimary;
  }
  /**
   * @param argb ARGB representation of a color.
   * @return Light Material color scheme, based on the color's hue.
   */
  static light(e) {
    return J.lightFromCorePalette(R.of(e));
  }
  /**
   * @param argb ARGB representation of a color.
   * @return Dark Material color scheme, based on the color's hue.
   */
  static dark(e) {
    return J.darkFromCorePalette(R.of(e));
  }
  /**
   * @param argb ARGB representation of a color.
   * @return Light Material content color scheme, based on the color's hue.
   */
  static lightContent(e) {
    return J.lightFromCorePalette(R.contentOf(e));
  }
  /**
   * @param argb ARGB representation of a color.
   * @return Dark Material content color scheme, based on the color's hue.
   */
  static darkContent(e) {
    return J.darkFromCorePalette(R.contentOf(e));
  }
  /**
   * Light scheme from core palette
   */
  static lightFromCorePalette(e) {
    return new J({
      primary: e.a1.tone(40),
      onPrimary: e.a1.tone(100),
      primaryContainer: e.a1.tone(90),
      onPrimaryContainer: e.a1.tone(10),
      secondary: e.a2.tone(40),
      onSecondary: e.a2.tone(100),
      secondaryContainer: e.a2.tone(90),
      onSecondaryContainer: e.a2.tone(10),
      tertiary: e.a3.tone(40),
      onTertiary: e.a3.tone(100),
      tertiaryContainer: e.a3.tone(90),
      onTertiaryContainer: e.a3.tone(10),
      error: e.error.tone(40),
      onError: e.error.tone(100),
      errorContainer: e.error.tone(90),
      onErrorContainer: e.error.tone(10),
      background: e.n1.tone(99),
      onBackground: e.n1.tone(10),
      surface: e.n1.tone(99),
      onSurface: e.n1.tone(10),
      surfaceVariant: e.n2.tone(90),
      onSurfaceVariant: e.n2.tone(30),
      outline: e.n2.tone(50),
      outlineVariant: e.n2.tone(80),
      shadow: e.n1.tone(0),
      scrim: e.n1.tone(0),
      inverseSurface: e.n1.tone(20),
      inverseOnSurface: e.n1.tone(95),
      inversePrimary: e.a1.tone(80)
    });
  }
  /**
   * Dark scheme from core palette
   */
  static darkFromCorePalette(e) {
    return new J({
      primary: e.a1.tone(80),
      onPrimary: e.a1.tone(20),
      primaryContainer: e.a1.tone(30),
      onPrimaryContainer: e.a1.tone(90),
      secondary: e.a2.tone(80),
      onSecondary: e.a2.tone(20),
      secondaryContainer: e.a2.tone(30),
      onSecondaryContainer: e.a2.tone(90),
      tertiary: e.a3.tone(80),
      onTertiary: e.a3.tone(20),
      tertiaryContainer: e.a3.tone(30),
      onTertiaryContainer: e.a3.tone(90),
      error: e.error.tone(80),
      onError: e.error.tone(20),
      errorContainer: e.error.tone(30),
      onErrorContainer: e.error.tone(80),
      background: e.n1.tone(10),
      onBackground: e.n1.tone(90),
      surface: e.n1.tone(10),
      onSurface: e.n1.tone(90),
      surfaceVariant: e.n2.tone(30),
      onSurfaceVariant: e.n2.tone(80),
      outline: e.n2.tone(60),
      outlineVariant: e.n2.tone(30),
      shadow: e.n1.tone(0),
      scrim: e.n1.tone(0),
      inverseSurface: e.n1.tone(90),
      inverseOnSurface: e.n1.tone(20),
      inversePrimary: e.a1.tone(40)
    });
  }
  constructor(e) {
    this.props = e;
  }
  toJSON() {
    return {
      ...this.props
    };
  }
}
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function T(t) {
  const e = At(t), r = Dt(t), a = wt(t), n = [e.toString(16), r.toString(16), a.toString(16)];
  for (const [o, s] of n.entries())
    s.length === 1 && (n[o] = "0" + s);
  return "#" + n.join("");
}
function q(t) {
  t = t.replace("#", "");
  const e = t.length === 3, r = t.length === 6, a = t.length === 8;
  if (!e && !r && !a)
    throw new Error("unexpected hex " + t);
  let n = 0, o = 0, s = 0;
  return e ? (n = G(t.slice(0, 1).repeat(2)), o = G(t.slice(1, 2).repeat(2)), s = G(t.slice(2, 3).repeat(2))) : r ? (n = G(t.slice(0, 2)), o = G(t.slice(2, 4)), s = G(t.slice(4, 6))) : a && (n = G(t.slice(2, 4)), o = G(t.slice(4, 6)), s = G(t.slice(6, 8))), (255 << 24 | (n & 255) << 16 | (o & 255) << 8 | s & 255) >>> 0;
}
function G(t) {
  return parseInt(t, 16);
}
/**
 * @license
 * Copyright 2021 Google LLC
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
function de(t, e = []) {
  const r = R.of(t);
  return {
    source: t,
    schemes: {
      light: J.light(t),
      dark: J.dark(t)
    },
    palettes: {
      primary: r.a1,
      secondary: r.a2,
      tertiary: r.a3,
      neutral: r.n1,
      neutralVariant: r.n2,
      error: r.error
    },
    customColors: e.map((a) => ge(t, a))
  };
}
function ge(t, e) {
  let r = e.value;
  const a = r, n = t;
  e.blend && (r = Ft.harmonize(a, n));
  const s = R.of(r).a1;
  return {
    color: e,
    value: r,
    light: {
      color: s.tone(40),
      onColor: s.tone(100),
      colorContainer: s.tone(90),
      onColorContainer: s.tone(10)
    },
    dark: {
      color: s.tone(80),
      onColor: s.tone(20),
      colorContainer: s.tone(30),
      onColorContainer: s.tone(90)
    }
  };
}
const be = {
  red: {
    50: "#ffebee",
    100: "#ffcdd2",
    200: "#ef9a9a",
    300: "#e57373",
    400: "#ef5350",
    500: "#f44336",
    600: "#e53935",
    700: "#d32f2f",
    800: "#c62828",
    900: "#b71c1c",
    A100: "#ff8a80",
    A200: "#ff5252",
    A400: "#ff1744",
    A700: "#d50000"
  },
  pink: {
    50: "#fce4ec",
    100: "#f8bbd0",
    200: "#f48fb1",
    300: "#f06292",
    400: "#ec407a",
    500: "#e91e63",
    600: "#d81b60",
    700: "#c2185b",
    800: "#ad1457",
    900: "#880e4f",
    A100: "#ff80ab",
    A200: "#ff4081",
    A400: "#f50057",
    A700: "#c51162"
  },
  purple: {
    50: "#f3e5f5",
    100: "#e1bee7",
    200: "#ce93d8",
    300: "#ba68c8",
    400: "#ab47bc",
    500: "#9c27b0",
    600: "#8e24aa",
    700: "#7b1fa2",
    800: "#6a1b9a",
    900: "#4a148c",
    A100: "#ea80fc",
    A200: "#e040fb",
    A400: "#d500f9",
    A700: "#aa00ff"
  },
  deepPurple: {
    50: "#ede7f6",
    100: "#d1c4e9",
    200: "#b39ddb",
    300: "#9575cd",
    400: "#7e57c2",
    500: "#673ab7",
    600: "#5e35b1",
    700: "#512da8",
    800: "#4527a0",
    900: "#311b92",
    A100: "#b388ff",
    A200: "#7c4dff",
    A400: "#651fff",
    A700: "#6200ea"
  },
  indigo: {
    50: "#e8eaf6",
    100: "#c5cae9",
    200: "#9fa8da",
    300: "#7986cb",
    400: "#5c6bc0",
    500: "#3f51b5",
    600: "#3949ab",
    700: "#303f9f",
    800: "#283593",
    900: "#1a237e",
    A100: "#8c9eff",
    A200: "#536dfe",
    A400: "#3d5afe",
    A700: "#304ffe"
  },
  blue: {
    50: "#e3f2fd",
    100: "#bbdefb",
    200: "#90caf9",
    300: "#64b5f6",
    400: "#42a5f5",
    500: "#2196f3",
    600: "#1e88e5",
    700: "#1976d2",
    800: "#1565c0",
    900: "#0d47a1",
    A100: "#82b1ff",
    A200: "#448aff",
    A400: "#2979ff",
    A700: "#2962ff"
  },
  lightBlue: {
    50: "#e1f5fe",
    100: "#b3e5fc",
    200: "#81d4fa",
    300: "#4fc3f7",
    400: "#29b6f6",
    500: "#03a9f4",
    600: "#039be5",
    700: "#0288d1",
    800: "#0277bd",
    900: "#01579b",
    A100: "#80d8ff",
    A200: "#40c4ff",
    A400: "#00b0ff",
    A700: "#0091ea"
  },
  cyan: {
    50: "#e0f7fa",
    100: "#b2ebf2",
    200: "#80deea",
    300: "#4dd0e1",
    400: "#26c6da",
    500: "#00bcd4",
    600: "#00acc1",
    700: "#0097a7",
    800: "#00838f",
    900: "#006064",
    A100: "#84ffff",
    A200: "#18ffff",
    A400: "#00e5ff",
    A700: "#00b8d4"
  },
  teal: {
    50: "#e0f2f1",
    100: "#b2dfdb",
    200: "#80cbc4",
    300: "#4db6ac",
    400: "#26a69a",
    500: "#009688",
    600: "#00897b",
    700: "#00796b",
    800: "#00695c",
    900: "#004d40",
    A100: "#a7ffeb",
    A200: "#64ffda",
    A400: "#1de9b6",
    A700: "#00bfa5"
  },
  green: {
    50: "#e8f5e9",
    100: "#c8e6c9",
    200: "#a5d6a7",
    300: "#81c784",
    400: "#66bb6a",
    500: "#4caf50",
    600: "#43a047",
    700: "#388e3c",
    800: "#2e7d32",
    900: "#1b5e20",
    A100: "#b9f6ca",
    A200: "#69f0ae",
    A400: "#00e676",
    A700: "#00c853"
  },
  lightGreen: {
    50: "#f1f8e9",
    100: "#dcedc8",
    200: "#c5e1a5",
    300: "#aed581",
    400: "#9ccc65",
    500: "#8bc34a",
    600: "#7cb342",
    700: "#689f38",
    800: "#558b2f",
    900: "#33691e",
    A100: "#ccff90",
    A200: "#b2ff59",
    A400: "#76ff03",
    A700: "#64dd17"
  },
  lime: {
    50: "#f9fbe7",
    100: "#f0f4c3",
    200: "#e6ee9c",
    300: "#dce775",
    400: "#d4e157",
    500: "#cddc39",
    600: "#c0ca33",
    700: "#afb42b",
    800: "#9e9d24",
    900: "#827717",
    A100: "#f4ff81",
    A200: "#eeff41",
    A400: "#c6ff00",
    A700: "#aeea00"
  },
  yellow: {
    50: "#fffde7",
    100: "#fff9c4",
    200: "#fff59d",
    300: "#fff176",
    400: "#ffee58",
    500: "#ffeb3b",
    600: "#fdd835",
    700: "#fbc02d",
    800: "#f9a825",
    900: "#f57f17",
    A100: "#ffff8d",
    A200: "#ffff00",
    A400: "#ffea00",
    A700: "#ffd600"
  },
  amber: {
    50: "#fff8e1",
    100: "#ffecb3",
    200: "#ffe082",
    300: "#ffd54f",
    400: "#ffca28",
    500: "#ffc107",
    600: "#ffb300",
    700: "#ffa000",
    800: "#ff8f00",
    900: "#ff6f00",
    A100: "#ffe57f",
    A200: "#ffd740",
    A400: "#ffc400",
    A700: "#ffab00"
  },
  orange: {
    50: "#fff3e0",
    100: "#ffe0b2",
    200: "#ffcc80",
    300: "#ffb74d",
    400: "#ffa726",
    500: "#ff9800",
    600: "#fb8c00",
    700: "#f57c00",
    800: "#ef6c00",
    900: "#e65100",
    A100: "#ffd180",
    A200: "#ffab40",
    A400: "#ff9100",
    A700: "#ff6d00"
  },
  deepOrange: {
    50: "#fbe9e7",
    100: "#ffccbc",
    200: "#ffab91",
    300: "#ff8a65",
    400: "#ff7043",
    500: "#ff5722",
    600: "#f4511e",
    700: "#e64a19",
    800: "#d84315",
    900: "#bf360c",
    A100: "#ff9e80",
    A200: "#ff6e40",
    A400: "#ff3d00",
    A700: "#dd2c00"
  },
  brown: {
    50: "#efebe9",
    100: "#d7ccc8",
    200: "#bcaaa4",
    300: "#a1887f",
    400: "#8d6e63",
    500: "#795548",
    600: "#6d4c41",
    700: "#5d4037",
    800: "#4e342e",
    900: "#3e2723"
  },
  grey: {
    50: "#fafafa",
    100: "#f5f5f5",
    200: "#eeeeee",
    300: "#e0e0e0",
    400: "#bdbdbd",
    500: "#9e9e9e",
    600: "#757575",
    700: "#616161",
    800: "#424242",
    900: "#212121"
  },
  blueGrey: {
    50: "#eceff1",
    100: "#cfd8dc",
    200: "#b0bec5",
    300: "#90a4ae",
    400: "#78909c",
    500: "#607d8b",
    600: "#546e7a",
    700: "#455a64",
    800: "#37474f",
    900: "#263238"
  }
}, xe = {
  dragged: "0.16",
  pressed: "0.12",
  focus: "0.12",
  hover: "0.08",
  disabled: "0.38"
}, ye = [
  "none",
  "0px 2px 1px -1px rgba(0, 0, 0, 0.2), 0px 1px 1px 0px rgba(0, 0, 0, 0.14), 0px 1px 3px 0px rgba(0, 0, 0, 0.12)",
  "0px 3px 1px -2px rgba(0, 0, 0, 0.2), 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 1px 5px 0px rgba(0, 0, 0, 0.12)",
  "0px 3px 3px -2px rgba(0, 0, 0, 0.2), 0px 3px 4px 0px rgba(0, 0, 0, 0.14), 0px 1px 8px 0px rgba(0, 0, 0, 0.12)",
  "0px 2px 4px -1px rgba(0, 0, 0, 0.2), 0px 4px 5px 0px rgba(0, 0, 0, 0.14), 0px 1px 10px 0px rgba(0, 0, 0, 0.12)",
  "0px 3px 5px -1px rgba(0, 0, 0, 0.2), 0px 5px 8px 0px rgba(0, 0, 0, 0.14), 0px 1px 14px 0px rgba(0, 0, 0, 0.12)",
  "0px 3px 5px -1px rgba(0, 0, 0, 0.2), 0px 6px 10px 0px rgba(0, 0, 0, 0.14), 0px 1px 18px 0px rgba(0, 0, 0, 0.12)",
  "0px 4px 5px -2px rgba(0, 0, 0, 0.2), 0px 7px 10px 1px rgba(0, 0, 0, 0.14), 0px 2px 16px 1px rgba(0, 0, 0, 0.12)",
  "0px 5px 5px -3px rgba(0, 0, 0, 0.2), 0px 8px 10px 1px rgba(0, 0, 0, 0.14), 0px 3px 14px 2px rgba(0, 0, 0, 0.12)",
  "0px 5px 6px -3px rgba(0, 0, 0, 0.2), 0px 9px 12px 1px rgba(0, 0, 0, 0.14), 0px 3px 16px 2px rgba(0, 0, 0, 0.12)",
  "0px 6px 6px -3px rgba(0, 0, 0, 0.2), 0px 10px 14px 1px rgba(0, 0, 0, 0.14), 0px 4px 18px 3px rgba(0, 0, 0, 0.12)",
  "0px 6px 7px -4px rgba(0, 0, 0, 0.2), 0px 11px 15px 1px rgba(0, 0, 0, 0.14), 0px 4px 20px 3px rgba(0, 0, 0, 0.12)",
  "0px 7px 8px -4px rgba(0, 0, 0, 0.2), 0px 12px 17px 2px rgba(0, 0, 0, 0.14), 0px 5px 22px 4px rgba(0, 0, 0, 0.12)",
  "0px 7px 8px -4px rgba(0, 0, 0, 0.2), 0px 13px 19px 2px rgba(0, 0, 0, 0.14), 0px 5px 24px 4px rgba(0, 0, 0, 0.12)",
  "0px 7px 9px -4px rgba(0, 0, 0, 0.2), 0px 14px 21px 2px rgba(0, 0, 0, 0.14), 0px 5px 26px 4px rgba(0, 0, 0, 0.12)",
  "0px 8px 9px -5px rgba(0, 0, 0, 0.2), 0px 15px 22px 2px rgba(0, 0, 0, 0.14), 0px 6px 28px 5px rgba(0, 0, 0, 0.12)",
  "0px 8px 10px -5px rgba(0, 0, 0, 0.2), 0px 16px 24px 2px rgba(0, 0, 0, 0.14), 0px 6px 30px 5px rgba(0, 0, 0, 0.12)",
  "0px 8px 11px -5px rgba(0, 0, 0, 0.2), 0px 17px 26px 2px rgba(0, 0, 0, 0.14), 0px 6px 32px 5px rgba(0, 0, 0, 0.12)",
  "0px 9px 11px -5px rgba(0, 0, 0, 0.2), 0px 18px 28px 2px rgba(0, 0, 0, 0.14), 0px 7px 34px 6px rgba(0, 0, 0, 0.12)",
  "0px 9px 12px -6px rgba(0, 0, 0, 0.2), 0px 19px 29px 2px rgba(0, 0, 0, 0.14), 0px 7px 36px 6px rgba(0, 0, 0, 0.12)",
  "0px 10px 13px -6px rgba(0, 0, 0, 0.2), 0px 20px 31px 3px rgba(0, 0, 0, 0.14), 0px 8px 38px 7px rgba(0, 0, 0, 0.12)",
  "0px 10px 13px -6px rgba(0, 0, 0, 0.2), 0px 21px 33px 3px rgba(0, 0, 0, 0.14), 0px 8px 40px 7px rgba(0, 0, 0, 0.12)",
  "0px 10px 14px -6px rgba(0, 0, 0, 0.2), 0px 22px 35px 3px rgba(0, 0, 0, 0.14), 0px 8px 42px 7px rgba(0, 0, 0, 0.12)",
  "0px 11px 14px -7px rgba(0, 0, 0, 0.2), 0px 23px 36px 3px rgba(0, 0, 0, 0.14), 0px 9px 44px 8px rgba(0, 0, 0, 0.12)",
  "0px 11px 15px -7px rgba(0, 0, 0, 0.2), 0px 24px 38px 3px rgba(0, 0, 0, 0.14), 0px 9px 46px 8px rgba(0, 0, 0, 0.12)"
], d = {
  fontFamily: '"IBM Plex Sans",-apple-system,BlinkMacSystemFont,"Segoe UI",Roboto,"Helvetica Neue",Arial,sans-serif,"Apple Color Emoji","Segoe UI Emoji","Segoe UI Symbol"',
  htmlFontSize: 16,
  fontSize: 14,
  pxToRem: (t) => {
    const e = d.fontSize / 14;
    return `${t / d.htmlFontSize * e}rem`;
  }
}, Ce = {
  ...d,
  h1: {
    fontFamily: "Roboto",
    fontWeight: 400,
    fontSize: d.pxToRem(57),
    fontStyle: "unset",
    letterSpacing: d.pxToRem(-0.25),
    lineHeight: d.pxToRem(64),
    textTransform: "unset"
  },
  h2: {
    fontFamily: "Roboto",
    fontWeight: 400,
    fontSize: d.pxToRem(45),
    fontStyle: "unset",
    letterSpacing: d.pxToRem(0),
    lineHeight: d.pxToRem(52),
    textTransform: "unset"
  },
  h3: {
    fontFamily: "Roboto",
    fontWeight: 400,
    fontSize: d.pxToRem(36),
    fontStyle: "unset",
    letterSpacing: d.pxToRem(0),
    lineHeight: d.pxToRem(44),
    textTransform: "unset"
  },
  h4: {
    fontFamily: "Roboto",
    fontWeight: 400,
    fontSize: d.pxToRem(32),
    fontStyle: "unset",
    letterSpacing: d.pxToRem(0),
    lineHeight: d.pxToRem(40),
    textTransform: "unset"
  },
  h5: {
    fontFamily: "Roboto",
    fontWeight: 400,
    fontSize: d.pxToRem(28),
    fontStyle: "unset",
    letterSpacing: d.pxToRem(0),
    lineHeight: d.pxToRem(36),
    textTransform: "unset"
  },
  h6: {
    fontFamily: "Roboto",
    fontWeight: 400,
    fontSize: d.pxToRem(24),
    fontStyle: "unset",
    letterSpacing: d.pxToRem(0),
    lineHeight: d.pxToRem(32),
    textTransform: "unset"
  },
  title: {
    small: {
      fontFamily: "Roboto",
      fontWeight: 500,
      fontSize: d.pxToRem(14),
      fontStyle: "unset",
      letterSpacing: d.pxToRem(0.1),
      lineHeight: d.pxToRem(20),
      textTransform: "unset"
    },
    medium: {
      fontFamily: "Roboto",
      fontWeight: 500,
      fontSize: d.pxToRem(16),
      fontStyle: "unset",
      letterSpacing: d.pxToRem(0.15000001),
      lineHeight: d.pxToRem(24),
      textTransform: "unset"
    },
    large: {
      fontFamily: "Roboto",
      fontWeight: 400,
      fontSize: d.pxToRem(22),
      fontStyle: "unset",
      letterSpacing: d.pxToRem(0),
      lineHeight: d.pxToRem(28),
      textTransform: "unset"
    }
  },
  body: {
    small: {
      fontFamily: "Roboto",
      fontWeight: 400,
      fontSize: d.pxToRem(12),
      fontStyle: "unset",
      letterSpacing: d.pxToRem(0.40000001),
      lineHeight: d.pxToRem(16),
      textTransform: "unset"
    },
    medium: {
      fontFamily: "Roboto",
      fontWeight: 400,
      fontSize: d.pxToRem(14),
      fontStyle: "unset",
      letterSpacing: d.pxToRem(0.25),
      lineHeight: d.pxToRem(20),
      textTransform: "unset"
    },
    large: {
      fontFamily: "Roboto",
      fontWeight: 400,
      fontSize: d.pxToRem(16),
      fontStyle: "unset",
      letterSpacing: d.pxToRem(0.5),
      lineHeight: d.pxToRem(24),
      textTransform: "unset"
    }
  },
  label: {
    small: {
      fontFamily: "Roboto",
      fontWeight: 500,
      fontSize: d.pxToRem(11),
      fontStyle: "unset",
      letterSpacing: d.pxToRem(0.5),
      lineHeight: d.pxToRem(16),
      textTransform: "unset"
    },
    medium: {
      fontFamily: "Roboto",
      fontWeight: 400,
      fontSize: d.pxToRem(12),
      fontStyle: "unset",
      letterSpacing: d.pxToRem(0.5),
      lineHeight: d.pxToRem(16),
      textTransform: "unset"
    },
    large: {
      fontFamily: "Roboto",
      fontWeight: 500,
      fontSize: d.pxToRem(14),
      fontStyle: "unset",
      letterSpacing: d.pxToRem(0.1),
      lineHeight: d.pxToRem(20),
      textTransform: "unset"
    }
  }
}, He = ["title", "body", "label"], Ne = [
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6"
], je = {
  h1: "h1",
  h2: "h2",
  h3: "h3",
  h4: "h4",
  h5: "h5",
  h6: "h6",
  title: "h6",
  body: "p",
  label: "span"
}, Pe = {
  50: 50,
  100: 100,
  150: 150,
  200: 200,
  250: 250,
  300: 300,
  350: 350,
  400: 400,
  450: 450,
  500: 500,
  550: 550,
  600: 600,
  700: 700,
  800: 800,
  900: 900,
  1e3: 1e3
}, ke = {
  "easing-standard": "cubic-bezier(0.2, 0, 0, 1)",
  "easing-linear": "cubic-bezier(0, 0, 1, 1)",
  "easing-standard-accelerate": "cubic-bezier(0.3, 0, 1, 1)",
  "easing-standard-decelerate": "cubic-bezier(0, 0, 0, 1)",
  "easing-emphasized": "cubic-bezier(0.2, 0, 0, 1)"
}, Te = (t, e = {}) => {
  const { duration: r = 300, timingFunction: a = "easing-standard" } = e;
  return `${t.map((n) => `${n} ${r}ms ${a}`).join(",")};`;
}, Me = {
  create: Te,
  duration: Pe,
  timingFunction: ke
}, Ae = {
  appBar: 1100,
  drawer: 1300,
  fab: 1050,
  stepper: 1100,
  modal: 1200
};
class Ut {
  constructor(e, r, a = "light", n, o, s) {
    this.colors = be, this.states = xe, this.elevations = ye, this.typography = Ce, this.zIndex = Ae, this.motion = Me, this.schemes = e, this.mode = a, this.palettes = r, this._lightSchemes = n, this._darkSchemes = o, this.target = s;
  }
  toggleMode() {
    this.mode = this.mode === "light" ? "dark" : "light";
  }
}
const $t = {
  source: "#6750A4",
  customColors: [
    {
      name: "success",
      value: q("#4caf50"),
      blend: !0
    },
    {
      name: "warning",
      value: q("#ff9800"),
      blend: !0
    },
    {
      name: "info",
      value: q("#2196f3"),
      blend: !0
    }
  ]
}, _t = [
  "0",
  "10",
  "20",
  "30",
  "40",
  "50",
  "60",
  "70",
  "80",
  "90",
  "95",
  "99",
  "100"
], De = (t) => {
  const e = {};
  for (const [r, a] of Object.entries(t)) {
    const n = {};
    _t.forEach(
      (o) => n[o] = T(
        a.tone(+o)
      )
    ), e[r] = n;
  }
  return e;
}, we = (t) => {
  const e = {};
  return t.forEach((r) => {
    const { name: a, value: n } = r, o = R.of(n).a1, s = {};
    _t.forEach(
      (c) => s[c] = T(
        o.tone(+c)
      )
    ), e[a.toLowerCase()] = s;
  }), e;
}, zt = (t) => {
  const e = {}, r = {};
  for (const [a, n] of Object.entries(t.toJSON())) {
    const o = a.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase(), s = T(n), { r: c, g: u, b: f } = at(n);
    e[a] = s, r[`--md-sys-color-${o}`] = s, r[`--md-sys-color-${o}-rgb`] = `${c} ${u} ${f}`;
  }
  return { schemes: e, styles: r };
}, vt = (t, e) => {
  const r = {}, a = {};
  return t.forEach((n) => {
    const { name: o } = n.color, s = e === "light" ? n.light : n.dark;
    for (const [c, u] of Object.entries(s)) {
      const f = c.startsWith("on") ? c.replace("Color", `${o[0].toUpperCase()}${o.slice(1)}`) : c.replace("color", o), l = f.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase(), m = T(u), { r: g, g: b, b: x } = at(u);
      r[f] = m, a[`--md-sys-color-${l}`] = m, a[`--md-sys-color-${l}-rgb`] = `${g} ${b} ${x}`;
    }
  }), { schemes: r, styles: a };
}, Et = (...t) => {
  const e = {}, r = {};
  return t.forEach((a) => {
    Object.assign(e, a.schemes), Object.assign(r, a.styles);
  }), { schemes: e, styles: r };
}, Fe = (t, e, r, a) => {
  const { fontFamily: n, htmlFontSize: o } = a.typography;
  let s;
  return t === "root" ? Zt({
    ":root": {
      colorScheme: "light",
      ...e == null ? void 0 : e.styles
    },
    ':root[data-theme="dark"]': {
      colorScheme: "dark",
      ...r == null ? void 0 : r.styles
    },
    html: {
      fontSize: o
    },
    body: {
      fontFamily: n,
      color: "var(--md-sys-color-on-surface)",
      fontSize: "1rem"
    }
  }) : s = yt({
    ...e == null ? void 0 : e.styles,
    '&[data-theme="dark"]': {
      ...r == null ? void 0 : r.styles
    }
  }), s;
}, Se = (t) => {
  const {
    palettes: { neutral: e, neutralVariant: r }
  } = t;
  return {
    light: {
      surfaceDim: e.tone(87),
      surface: e.tone(98),
      surfaceBright: e.tone(98),
      surfaceContainerLowest: e.tone(100),
      surfaceContainerLow: e.tone(96),
      surfaceContainer: e.tone(94),
      surfaceContainerHigh: e.tone(92),
      surfaceContainerHighest: e.tone(90),
      onSurface: e.tone(10),
      onSurfaceVariant: r.tone(30),
      outline: r.tone(50),
      outlineVariant: r.tone(80)
    },
    dark: {
      surfaceDim: e.tone(6),
      surface: e.tone(6),
      surfaceBright: e.tone(24),
      surfaceContainerLowest: e.tone(4),
      surfaceContainerLow: e.tone(10),
      surfaceContainer: e.tone(12),
      surfaceContainerHigh: e.tone(17),
      surfaceContainerHighest: e.tone(22),
      onSurface: e.tone(90),
      onSurfaceVariant: r.tone(80),
      outline: r.tone(60),
      outlineVariant: r.tone(30)
    }
  };
}, Vt = (t) => {
  const e = {}, r = {};
  for (const [a, n] of Object.entries(t)) {
    const o = a.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase(), s = T(n), { r: c, g: u, b: f } = at(n);
    e[a] = s, r[`--md-sys-color-${o}`] = s, r[`--md-sys-color-${o}-rgb`] = `${c} ${u} ${f}`;
  }
  return { schemes: e, styles: r };
}, Re = (t) => {
  if (!t.startsWith("#"))
    throw new Error("The color must be the hex color");
  return at(q(t));
}, Ie = (t = $t.source, e = { target: "root" }) => {
  const r = e.config ?? {}, a = e.target, { schemes: n, mode: o } = r, s = [
    ...$t.customColors,
    ...r.customColors ?? []
  ], c = de(q(t), s), u = {
    ...De(c.palettes),
    ...we(s)
  }, f = Se(c), l = Et(
    zt(c.schemes.light),
    Vt(f.light),
    vt(c.customColors, "light")
  ), m = Et(
    zt(c.schemes.dark),
    Vt(f.dark),
    vt(c.customColors, "dark")
  ), { schemes: g } = o === "dark" ? m : l;
  return Q(
    new Ut(
      { ...g, ...n },
      u,
      o,
      l,
      m,
      a
    )
  );
}, ut = (t) => Xt(
  "ThemeContext",
  () => Ie(void 0, { target: "host", config: { mode: t } }),
  !0
), We = (t, e) => (r, ...a) => {
  const n = ut();
  return /* @__PURE__ */ Nt({
    setup(o, {
      slots: s
    }) {
      const c = ct(() => r instanceof Function ? yt(r(n == null ? void 0 : n.value)) : yt(r, ...a));
      return () => jt(t, Kt(e, {
        class: c.value
      }), {
        default: () => {
          var f;
          return [(f = s == null ? void 0 : s.default) == null ? void 0 : f.call(s)];
        }
      });
    }
  });
};
class W {
  constructor(e) {
    this.props = e;
  }
  static light(e, r) {
    if (e.startsWith("#")) {
      const n = R.of(q(e));
      return new W({
        primary: n.a1.tone(40),
        onPrimary: n.a1.tone(100),
        primaryContainer: n.a1.tone(90),
        onPrimaryContainer: n.a1.tone(10),
        secondary: n.a2.tone(40),
        onSecondary: n.a2.tone(100),
        secondaryContainer: n.a2.tone(90),
        onSecondaryContainer: n.a2.tone(10),
        tertiary: n.a3.tone(40),
        onTertiary: n.a3.tone(100),
        tertiaryContainer: n.a3.tone(90),
        onTertiaryContainer: n.a3.tone(10),
        surfaceDim: n.n1.tone(87),
        surface: n.n1.tone(98),
        surfaceBright: n.n1.tone(98),
        surfaceContainerLowest: n.n1.tone(100),
        surfaceContainerLow: n.n1.tone(96),
        surfaceContainer: n.n1.tone(94),
        surfaceContainerHigh: n.n1.tone(92),
        surfaceContainerHighest: n.n1.tone(90),
        onSurface: n.n1.tone(10),
        onSurfaceVariant: n.n2.tone(30),
        outline: n.n2.tone(50),
        outlineVariant: n.n2.tone(80)
      });
    }
    return W.schemesFromTheme(e, r);
  }
  static dark(e, r) {
    if (e.startsWith("#")) {
      const n = R.of(q(e));
      return new W({
        primary: n.a1.tone(80),
        onPrimary: n.a1.tone(20),
        primaryContainer: n.a1.tone(30),
        onPrimaryContainer: n.a1.tone(90),
        secondary: n.a2.tone(80),
        onSecondary: n.a2.tone(20),
        secondaryContainer: n.a2.tone(30),
        onSecondaryContainer: n.a2.tone(90),
        tertiary: n.a3.tone(80),
        onTertiary: n.a3.tone(20),
        tertiaryContainer: n.a3.tone(30),
        onTertiaryContainer: n.a3.tone(90),
        surfaceDim: n.n1.tone(6),
        surface: n.n1.tone(6),
        surfaceBright: n.n1.tone(24),
        surfaceContainerLowest: n.n1.tone(4),
        surfaceContainerLow: n.n1.tone(10),
        surfaceContainer: n.n1.tone(12),
        surfaceContainerHigh: n.n1.tone(17),
        surfaceContainerHighest: n.n1.tone(22),
        onSurface: n.n1.tone(90),
        onSurfaceVariant: n.n2.tone(80),
        outline: n.n2.tone(60),
        outlineVariant: n.n2.tone(30)
      });
    }
    return W.schemesFromTheme(e, r);
  }
  static schemesFromTheme(e, r) {
    const a = W.colorSet(e, r, "primary"), n = W.colorSet(
      "secondary",
      r,
      "secondary"
    ), o = W.colorSet("tertiary", r, "tertiary");
    return new W({
      ...a,
      ...n,
      ...o,
      surfaceDim: "var(--md-sys-color-surface-dim)",
      surface: "var(--md-sys-color-surface)",
      surfaceBright: "var(--md-sys-color-surface-bright)",
      surfaceContainerLowest: "var(--md-sys-color-surface-container-lowest)",
      surfaceContainerLow: "var(--md-sys-color-surface-container-low)",
      surfaceContainer: "var(--md-sys-color-surface-container)",
      surfaceContainerHigh: "var(--md-sys-color-surface-container-high)",
      surfaceContainerHighest: "var(--md-sys-color-surface-container-highest)",
      onSurface: "var(--md-sys-color-on-surface)",
      onSurfaceVariant: "var(--md-sys-color-on-surface-variant)",
      outline: "var(--md-sys-color-outline)",
      outlineVariant: "var(--md-sys-color-outline-variant)"
    });
  }
  static colorSet(e, r, a) {
    const n = e in r.schemes ? `var(--md-sys-color-${tt(e)})` : e, o = `on${rt(e)}` in r.schemes ? `var(--md-sys-color-on-${tt(e)})` : `var(--md-sys-color-on-${tt(a)})`, s = `${a}Container` in r.schemes ? `var(--md-sys-color-${tt(e)}-container)` : `var(--md-sys-color-${tt(a)}-container)`, c = `on${rt(a)}Container` in r.schemes ? `var(--md-sys-color-on-${tt(e)}-container)` : `var(--md-sys-color-on-${tt(a)}-container)`;
    return {
      [a]: n,
      [`on${rt(a)}`]: o,
      [`${a}Container`]: s,
      [`on${rt(a)}Container`]: c
    };
  }
  get primary() {
    return w(this.props.primary) ? this.props.primary : T(this.props.primary);
  }
  get onPrimary() {
    return w(this.props.onPrimary) ? this.props.onPrimary : T(this.props.onPrimary);
  }
  get primaryContainer() {
    return w(this.props.primaryContainer) ? this.props.primaryContainer : T(this.props.primaryContainer);
  }
  get onPrimaryContainer() {
    return w(this.props.onPrimaryContainer) ? this.props.onPrimaryContainer : T(this.props.onPrimaryContainer);
  }
  get secondary() {
    return w(this.props.secondary) ? this.props.secondary : T(this.props.secondary);
  }
  get onSecondary() {
    return w(this.props.onSecondary) ? this.props.onSecondary : T(this.props.onSecondary);
  }
  get secondaryContainer() {
    return w(this.props.secondaryContainer) ? this.props.secondaryContainer : T(this.props.secondaryContainer);
  }
  get onSecondaryContainer() {
    return w(this.props.onSecondaryContainer) ? this.props.onSecondaryContainer : T(this.props.onSecondaryContainer);
  }
  get tertiary() {
    return w(this.props.tertiary) ? this.props.tertiary : T(this.props.tertiary);
  }
  get onTertiary() {
    return w(this.props.onTertiary) ? this.props.onTertiary : T(this.props.onTertiary);
  }
  get tertiaryContainer() {
    return w(this.props.tertiaryContainer) ? this.props.tertiaryContainer : T(this.props.tertiaryContainer);
  }
  get onTertiaryContainer() {
    return w(this.props.onTertiaryContainer) ? this.props.onTertiaryContainer : T(this.props.onTertiaryContainer);
  }
  get surfaceDim() {
    return w(this.props.surfaceDim) ? this.props.surfaceDim : T(this.props.surfaceDim);
  }
  get surface() {
    return w(this.props.surface) ? this.props.surface : T(this.props.surface);
  }
  get surfaceBright() {
    return w(this.props.surfaceBright) ? this.props.surfaceBright : T(this.props.surfaceBright);
  }
  get surfaceContainerLowest() {
    return w(this.props.surfaceContainerLowest) ? this.props.surfaceContainerLowest : T(this.props.surfaceContainerLowest);
  }
  get surfaceContainerLow() {
    return w(this.props.surfaceContainerLow) ? this.props.surfaceContainerLow : T(this.props.surfaceContainerLow);
  }
  get surfaceContainer() {
    return w(this.props.surfaceContainer) ? this.props.surfaceContainer : T(this.props.surfaceContainer);
  }
  get surfaceContainerHigh() {
    return w(this.props.surfaceContainerHigh) ? this.props.surfaceContainerHigh : T(this.props.surfaceContainerHigh);
  }
  get surfaceContainerHighest() {
    return w(this.props.surfaceContainerHighest) ? this.props.surfaceContainerHighest : T(this.props.surfaceContainerHighest);
  }
  get onSurface() {
    return w(this.props.onSurface) ? this.props.onSurface : T(this.props.onSurface);
  }
  get onSurfaceVariant() {
    return w(this.props.onSurfaceVariant) ? this.props.onSurfaceVariant : T(this.props.onSurfaceVariant);
  }
  get outline() {
    return w(this.props.outline) ? this.props.outline : T(this.props.outline);
  }
  get outlineVariant() {
    return w(this.props.outlineVariant) ? this.props.outlineVariant : T(this.props.outlineVariant);
  }
}
const Be = (t, e, r) => ct(() => {
  const a = t == null ? void 0 : t[e];
  return typeof a == "function" ? a(r.value) : a in r.value.schemes ? `var(--md-sys-color-${a.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase()})` : a;
}), Le = (t, e, r) => ct(() => {
  const a = t == null ? void 0 : t[e];
  let n;
  if (typeof a == "function")
    n = a(r.value);
  else if (a in r.value.schemes) {
    const c = a.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase();
    if (a.startsWith("on"))
      return `var(--md-sys-color-${c})`;
    if (`on${rt(a)}` in r.value.schemes)
      return `var(--md-sys-color-on-${c})`;
    n = r.value.schemes[a];
  } else if (a.startsWith("#"))
    n = a;
  else
    return "var(--md-sys-color-on-surface)";
  const o = R.of(q(n)).a1, s = r.value.mode === "dark" ? o.tone(20) : o.tone(100);
  return T(s);
}), Ue = (t, e) => {
  const r = ut();
  if (!e || !(e in t) || !["string", "function"].includes(typeof t[e]))
    return [Q(null), Q(null)];
  const a = Be(t, e, r), n = Le(t, e, r);
  return [a, n];
}, Ht = (t) => {
  if (!t.startsWith("#"))
    throw new Error("The color must be the hex color");
  return at(q(t));
}, Oe = (t, e, r) => ct(() => {
  const a = t == null ? void 0 : t[e];
  if (typeof a == "function") {
    const { r: c, g: u, b: f } = Ht(a(r.value));
    return `${c} ${u} ${f}`;
  }
  if (a in r.value.schemes)
    return `var(--md-sys-color-${a.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase()}-rgb)`;
  if (!a.startsWith("#"))
    return a;
  const { r: n, g: o, b: s } = Ht(a);
  return `${n} ${o} ${s}`;
}), $e = (t, e, r) => ct(() => {
  const a = t == null ? void 0 : t[e];
  let n;
  if (typeof a == "function")
    n = a(r.value);
  else if (a in r.value.schemes) {
    const l = a.replace(/([a-z])([A-Z])/g, "$1-$2").toLowerCase();
    if (a.startsWith("on"))
      return `var(--md-sys-color-${l}-rgb)`;
    if (`on${rt(a)}` in r.value.schemes)
      return `var(--md-sys-color-on-${l}-rgb)`;
    n = r.value.schemes[a];
  } else if (a.startsWith("#"))
    n = a;
  else
    return "var(--md-sys-color-on-surface-rgb)";
  const o = R.of(q(n)).a1, s = r.value.mode === "dark" ? o.tone(20) : o.tone(100), { r: c, g: u, b: f } = at(s);
  return `${c} ${u} ${f}`;
}), _e = (t, e) => {
  const r = ut();
  if (!e || !(e in t) || !["string", "function"].includes(typeof t[e]))
    return [Q(null), Q(null)];
  const a = Oe(t, e, r), n = $e(t, e, r);
  return [a, n];
}, ze = (t) => {
  Qt("ThemeContext", t);
}, qe = (t) => {
  if (!t)
    return { light: null, dark: null, source: t };
  const e = ut(), r = typeof t == "function" ? t(e.value) : t;
  return {
    source: r,
    light: W.light(r, e.value),
    dark: W.dark(r, e.value)
  };
}, Ye = (t) => {
  if (t.startsWith("var"))
    return t.replace(")", "-rgb)");
  if (t.startsWith("#")) {
    const { r: e, g: r, b: a } = Re(t);
    return `${e} ${r} ${a}`;
  }
  return t;
}, Ge = /* @__PURE__ */ Nt({
  name: "ThemeProvider",
  props: {
    theme: {
      type: Object,
      required: !0
    },
    component: {
      type: [String, Object],
      default: "div"
    },
    watcher: {
      type: Function
    }
  },
  emits: ["update:theme"],
  setup(t, {
    slots: e,
    emit: r
  }) {
    const a = document.documentElement, n = Q(t.theme), o = t.theme.target === "host" ? ut() : Q(null), s = Q(null), c = n.value._lightSchemes, u = n.value._darkSchemes, f = Fe(n.value.target, c, u, n.value), l = (b) => {
      const x = t.theme.target === "root" ? a : s.value, {
        schemes: y
      } = b === "dark" ? u : c;
      b === "dark" ? x.setAttribute("data-theme", "dark") : x.removeAttribute("data-theme");
      const {
        palettes: M,
        target: F,
        schemes: D
      } = n.value;
      n.value = new Ut({
        ...D,
        ...y
      }, M, b, c, u, F), r("update:theme", n.value);
    }, m = t.theme.target === "root" ? () => t.theme.mode : () => {
      var b;
      return ((b = o.value) == null ? void 0 : b.mode) ?? t.theme.mode;
    };
    t.watcher ? t.watcher() : te(m, l), ze(n);
    const g = t.component;
    return () => {
      var b;
      return (
        // eslint-disable-next-line multiline-ternary
        n.value.target === "root" ? (b = e.default) == null ? void 0 : b.call(e) : jt(g, {
          ref: s,
          class: f
        }, {
          default: () => {
            var x;
            return [(x = e.default) == null ? void 0 : x.call(e)];
          }
        })
      );
    };
  }
});
export {
  W as ComponentSchemes,
  Ut as Theme,
  Ge as ThemeProvider,
  we as createCustomPalettes,
  Ie as createTheme,
  Ie as default,
  Fe as injectJSS,
  Et as mergeParsedSchemes,
  Se as newSchemes,
  vt as parseCustomSchemes,
  De as parsePalettes,
  zt as parseSchemes,
  Vt as parsedNewSchemes,
  We as styled,
  je as typographyMapping,
  He as typographyWithSize,
  Ne as typographyWithoutSize,
  Ue as useColor,
  qe as useDynamicColor,
  Ye as useDynamicRgb,
  _e as useRgbColor,
  ut as useTheme,
  ze as useThemeProvider
};
